#import "BezelImageView.h"
#import "CellAttributeExtension.h"

@implementation BezelImageView

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	[self setBgColor:[NSColor blackColor]];
//	[self setImageScaling:NSScaleProportionally];

}
//------------------------------------
// drawRect
//------------------------------------
- (void)drawRect:(NSRect)rect
{
	// draw background
	[[self bgColor] set];
	NSRectFill([self bounds]);

	[super drawRect:rect];

}
//------------------------------------
// mouseDown
//------------------------------------
- (void)mouseDown:(NSEvent *)event
{
	// double clicked
	if([event type] == NSLeftMouseDown){
		if([event clickCount] == 2){
			[tbvBezelList playItem:nil];
		}
	}
}
//------------------------------------
// scrollWheel
//------------------------------------
- (void)scrollWheel:(NSEvent *)theEvent
{
	int wheelDelta;

	wheelDelta = [theEvent deltaY];

	if(wheelDelta <= 0){
		[tbvBezelList selectNextRow:nil];
	}else{
		[tbvBezelList selectPreviousRow:nil];
	}

}

//------------------------------------
// bgColor
//------------------------------------
- (void)setBgColor:(NSColor*)bgColor
{
	[bgColor retain];
	[bgColor_ release];
	bgColor_ = bgColor;
}

- (NSColor*)bgColor
{
    return bgColor_;
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[bgColor_ release];
    [super dealloc];
}

@end
