#import "BezelListTableView.h"
#import "ExecuteMAME.h"

@implementation BezelListTableView

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// set delegate
	[super setDelegate:self];
	[super setDataSource:self];

	// set double clicked action
	[self setTarget:self];
	[self setDoubleAction:@selector(playItem:)];

}
//=======================================================================
// IBAction
//=======================================================================
//------------------------------------
// playItem
//------------------------------------
- (IBAction)playItem:(id)sender
{
	[executeMAME executeMameWithBezel:nil];
}
//------------------------------------
// selectPreviousRow
//------------------------------------
- (IBAction)selectNextRow:(id)sender
{
	[self moveRowIndex:1];
}
//------------------------------------
// selectPreviousRow
//------------------------------------
- (IBAction)selectPreviousRow:(id)sender
{
	[self moveRowIndex:0];
}
//------------------------------------
// moveRowIndex
//------------------------------------
- (void)moveRowIndex:(int)tag
{
	int index = [[self selectedRowIndexes] firstIndex];

	if(tag == 0){
		index--;
	}else{
		index++;
	}

	if(index < 0){index = 0;}
	if(index > [self numberOfRows] - 1){index = [self numberOfRows] - 1;}

	[self selectRow:index byExtendingSelection:NO];
}

//=======================================================================
// bind to tableview column
//=======================================================================
- (id)tableView:(NSTableView *)aTableView
        objectValueForTableColumn:(NSTableColumn *)aTableColumn
        row:(int)rowIndex
{

	if([[executeMAME bezelList] count] <= 0){
		return nil;
	}

	id record = [[executeMAME bezelList] objectAtIndex:rowIndex];

	// icon
	if([[aTableColumn identifier] isEqualToString:@"icon"]){
		return [record valueForKey:@"iconImage"];
	}
	// title
	else if([[aTableColumn identifier] isEqualToString:@"title"]){
		return [record valueForKey:@"title"];
	}

    return nil;
}
//------------------------------------
// numberOfRowsInTableView
//------------------------------------
- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return [[executeMAME bezelList] count];
}
//------------------------------------
// shouldEditTableColumn
//------------------------------------
-(BOOL)tableView:(NSTableView *)tableView shouldEditTableColumn:(NSTableColumn *)tableColumn row:(int)rowIndex
{
	return NO;
}
//------------------------------------
// tableViewSelectionDidChange
//------------------------------------
-(void)tableViewSelectionDidChange:(NSNotification *)aNotification
{
	[executeMAME changeBezelImageView:nil];
}
/*
//------------------------------------
// scrollWheel
//------------------------------------
- (void)scrollWheel:(NSEvent *)theEvent
{
	int wheelDelta;

	wheelDelta = [theEvent deltaY];

	if(wheelDelta <= 0){
		[self selectNextRow:nil];
	}else{
		[self selectPreviousRow:nil];
	}

}
*/
//----------------------
// dealloc
//----------------------
- (void)dealloc
{
	[super dealloc];
}
@end
