#import "CMRomlistHeader.h"
#import "RomlistTableView.h"

@implementation CMRomlistHeader

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	//set delegate parent menu
	[super setDelegate:self];

}
//------------------------------------
// set Menu Item
//------------------------------------
-(void)setMenuItem
{

	NSArray *myColmun;
	NSString *title;
	NSString *identifier;
	NSString *senderString;
	int state;
	id record;

	// remove all items
    NSEnumerator *enumItemArray = [[self itemArray] objectEnumerator];
    while (record = [enumItemArray nextObject]) {
		[self removeItem:record];
	}

	// add item 
	NSArray *menuItems = [self menuItems];
    NSEnumerator *enumColArray = [menuItems objectEnumerator];
	NSMenuItem *menuItem;

    while (record = [enumColArray nextObject]) {

		myColmun = [record componentsSeparatedByString:@","];
		title = [myColmun objectAtIndex:0];
		identifier = [myColmun objectAtIndex:1];

		if([romlistTableView isShowColumn:identifier] == YES){
			state = 1;
		}else{
			state = 0;
		}

		senderString = [NSString stringWithFormat: @"%@,%d",identifier,state];

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:@selector(changeColumnState:) keyEquivalent:@""] autorelease];
		[menuItem setTarget:romlistTableView];
		[menuItem setRepresentedObject:senderString];
		[menuItem setState:state];
         
        [self addItem:menuItem];
    }
	[menuItems release];

}
//------------------------------------
// menuItems
//------------------------------------
-(NSArray*)menuItems
{

	return 	[[NSArray alloc] initWithObjects:
				@"Image,image",
//				@"Description,description",
//				@"Title,title",
//				@"TitleJP,titlejp",
				@"Manufacture,manufacture",
				@"Clones,cloneCount",
				@"Plays,playCount",
				@"Year,year",
//				@"ID,id",
				@"Size,fileSize",
				@"Date,fileDate",
				@"AuditIcon,auditIcon",
				@"AuditStatus,auditStatus",
				@"ImportVersion,addVersion",
				@"Tag,comment",
				nil
			];
}
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self setMenuItem];
}

@end
