/* ConvertExtension */

#import <Cocoa/Cocoa.h>

@interface NSObject(convertExtension_)

- (NSString*)converToAppHomePath;
- (NSString*)converToBezelHomePath;
- (NSString*)converToBezelTemplatesPath;
- (NSString*)converToBezelLayoutsPath;
- (NSString*)converToBezelImagesPath;
- (NSString*)converToBezelIconsPath;

- (NSString*)converToBezelIconFilePath:(NSString*)fileName;
- (NSString*)converToBezelTemplateFilePath:(NSString*)fileName;
- (NSString*)converToBezelTemplateListPath;


- (NSString*)converToBezelTempPath;
- (NSString*)converToBezelTempFolderPath:(NSString*)folderPath romId:(NSString*)romId;
- (NSString*)converToBezelTempFilePath:(NSString*)folderPath romId:(NSString*)romId;
- (NSString*)converToBezelFileNameWithSubImage:(NSString*)fileName;

- (NSString*)convertFileSizeToString:(double)fileSize;
- (NSString*)convertTimeToString:(int)timeSec;
- (NSString*)convertDateToString:(NSDate*)date formatString:(NSString*)formatString;

- (NSString*)convertToComma:(int)value;
- (NSString*)convertToZeroFormat:(int)value;

- (NSString*)convertToResultString:(int)startIndex endIndex:(int)endIndex totalResults:(int)totalResults;

- (NSString*)decodeToPercentEscapesString:(NSString*)string;
- (NSString*)encodeFromPercentEscapesString:(NSString*)string;

- (NSString*)replaceCharacter:(NSString*)string str1:(NSString*)str1 str2:(NSString*)str2;
- (BOOL)checkIsExistCharacterSet:(NSString*)string cSet:(NSCharacterSet*)cSet;
- (NSString*)trimKeywordFromString:(NSString*)string;

- (id)getDefaultRomSet:(id)record isClone:(BOOL*)isClone;
- (NSString*)getTitleString:(int)langType
							title:(NSString*)title
							titlejp:(NSString*)titlejp;
- (NSString*)createToolTipString:(id)record isClone:(BOOL)isClone;
- (NSString*)getLastSeparatedString:(NSString*)str sep:(NSString*)sep;

@end
