/* DialogExtension */

#import <Cocoa/Cocoa.h>
#import "WindowInfoStatus.h"

@interface NSObject(dialogExtension_)
	
- (int)displayMessage:(NSString *)messageStyle
					messageText:(NSString *)messageText
					infoText:(NSString *)infoText
					btnList:(NSString *)btnList;

- (int)displayMessageWithIcon:(NSString *)iconName
					messageText:(NSString *)messageText
					infoText:(NSString *)infoText
					btnList:(NSString *)btnList;

- (int)displayMessageAlertFileIsNotFound:(NSString*)filePath;
- (int)displayMessageAlertRomFileIsNotFound:(NSString*)romId isParent:(BOOL)isParent;
- (int)displayMessageAlertFolderIsNotMatch:(NSString*)filePath1 filePath2:(NSString*)filePath2;
- (int)displayMessageAlertAppIsNotFound:(NSString*)filePath;
- (int)displayMessageAlertExecutionFile;
- (int)displayMessageAlertRunningTask;


- (int)displayMessageAlertFolder:(NSString*)folderName;

- (NSArray*)selectFilePathWithOpenPanel:(BOOL)isFile
								isDir:(BOOL)isDir
								isMultiSel:(BOOL)isMultiSel
								isPackage:(BOOL)isPackage
								isAlias:(BOOL)isAlias
								canCreateDir:(BOOL)canCreateDir
								defaultPath:(NSString*)defaultPath;
- (NSString*)selectFilePathWithSavePanel:(NSString*)fileName
						canCreateDir:(BOOL)canCreateDir
						defaultPath:(NSString*)defaultPath;

- (void)postDialogOpenedNotification;
@end
