/* ExecuteMAME */

#import <Cocoa/Cocoa.h>
#import "BezelImageView.h"
#import "ItemInfoStatus.h"

@interface ExecuteMAME : NSObject
{

	IBOutlet id viewLog;
	IBOutlet id viewPrefs;
	IBOutlet id tbArrayController;

	IBOutlet NSWindow *replaySettingWindow;
	IBOutlet NSMatrix *replayTypeMatrix;
	IBOutlet NSTextField *txtRecordFile;
	IBOutlet NSPopUpButton *pbtnPlaybackFiles;
	IBOutlet NSButton *btnReplayPlay;
	IBOutlet NSButton *btnReplayCancel;

	IBOutlet NSWindow *bezelSettingWindow;
	IBOutlet BezelImageView *imageBezel;
	IBOutlet NSTableView *tbvBezelList;
	IBOutlet NSButton *btnBezelShowSubImage;
	IBOutlet NSButton *btnBezelPlay;
	IBOutlet NSButton *btnBezelCancel;
	IBOutlet NSSlider *sliderBezelAlpha;

	NSDictionary *playParams_;
	NSDictionary *replayParams_;
	NSDictionary *bezelParams_;

	NSMutableArray *bezelList_;

	NSTask *task_;
	NSString *logString_;

}

- (IBAction)openReplaySettingWindow:(id)sender;
- (IBAction)openBezelSettingWindow:(id)sender;
- (IBAction)closeReplaySettingWindow:(id)sender;
- (IBAction)closeBezelSettingWindow:(id)sender;
- (IBAction)executeMameWithReplay:(id)sender;
- (IBAction)executeMameWithBezel:(id)sender;

- (IBAction)changeReplayType:(id)sender;
- (IBAction)changeBezelImageView:(id)sender;

- (void)playItem:(NSDictionary*)playParams;
- (BOOL)playItemWithReplay:(NSDictionary*)playParams;
- (BOOL)playItemWithBezel:(NSDictionary*)playParams;

- (void)executeMame:(NSDictionary*)playParams
		replayParams:(NSDictionary*)replayParams
		bezelParams:(NSDictionary*)bezelParams;
- (BOOL)executeSdlMame:(NSString*)romId
				parentId:(NSString*)parentId
				bezelParams:(NSDictionary*)bezelParams
				replayParams:(NSDictionary*)replayParams;
- (BOOL)executeMameOSX:(NSString*)romId parentId:(NSString*)parentId;
- (BOOL)executeMacMame:(NSString*)romId parentId:(NSString*)parentId;

- (void)updatePlayCount:(NSString*)romId;
- (void)handleTaskResult:(NSNotification *)aNotification;

- (void)setTask:(NSTask*)task;
- (NSTask*)task;

- (void)setPlayParams:(NSDictionary*)playParams;
- (NSDictionary*)playParams;
- (void)setReplayParams:(NSDictionary*)replayParams;
- (NSDictionary*)replayParams;
- (void)setBezelParams:(NSDictionary*)bezelParams;
- (NSDictionary*)bezelParams;

- (NSMutableArray*)bezelList;

- (void)setLogString:(NSString*)logString;
- (void)appendLogString:(NSString*)logString;
- (NSString*)logString;

- (BOOL)isSelectSdlmame;


@end
