#import "ImageBindController.h"
#import "UserDefaultsExtension.h"

static const int ICON_SIZE = 14;
 
@implementation ImageBindController

//------------------------------------
// createImage
//------------------------------------
- (NSImage*)createImage:(NSString*)imageName
{

	if([self defaultBoolValue:@"optShowMenuIcon"] == YES){
		NSImage *image = [[[NSImage alloc] initByReferencingFile:[[NSBundle mainBundle] pathForResource:imageName ofType:@"png"]] autorelease];
		[image setScalesWhenResized:YES];
		[image setSize:NSMakeSize(ICON_SIZE,ICON_SIZE)];
		return image;
//		return [NSImage imageNamed:imageName];
	}else{
		return nil;
	}

}

//------------------------------------
// iconVideo
//------------------------------------
- (NSImage*)iconVideo
{
	return [self createImage:@"icon_video"];
}
//------------------------------------
// iconPlay
//------------------------------------
- (NSImage*)iconPlay
{
	return [self createImage:@"icon_play"];
}
//------------------------------------
// iconPicture
//------------------------------------
- (NSImage*)iconPicture
{
	return [self createImage:@"icon_picture"];
}
//------------------------------------
// iconPlaylist
//------------------------------------
- (NSImage*)iconPlaylist
{
	return [self createImage:@"icon_playlist"];
}
//------------------------------------
// iconPlaylistGray
//------------------------------------
- (NSImage*)iconPlaylistGray
{
	return [self createImage:@"icon_playlist_gray"];
}
//------------------------------------
// iconFolder
//------------------------------------
- (NSImage*)iconFolder
{
	return [self createImage:@"icon_folder"];
}
//------------------------------------
// iconSearch
//------------------------------------
- (NSImage*)iconSearch
{
	return [self createImage:@"icon_search"];
}
//------------------------------------
// iconSearchBlue
//------------------------------------
- (NSImage*)iconSearchBlue
{
	return [self createImage:@"icon_search_blue"];
}
//------------------------------------
// iconWebSearch
//------------------------------------
- (NSImage*)iconWebSearch
{
	return [self createImage:@"icon_websearch"];
}
//------------------------------------
// iconRoms
//------------------------------------
- (NSImage*)iconRoms
{
	return [self createImage:@"icon_roms"];
}
//------------------------------------
// iconEdit
//------------------------------------
- (NSImage*)iconEdit
{
	return [self createImage:@"icon_edit"];
}
//------------------------------------
// iconUpdate
//------------------------------------
- (NSImage*)iconUpdate;
{
	return [self createImage:@"icon_update"];
}

//------------------------------------
// iconLabel
//------------------------------------
- (NSImage*)iconLabel
{
	return [self createImage:@"icon_label"];
}
//------------------------------------
// iconGear
//------------------------------------
- (NSImage*)iconGear
{
	return [self createImage:@"icon_gear"];
}
//------------------------------------
// iconItemInfo
//------------------------------------
- (NSImage*)iconItemInfo
{
	return [self createImage:@"icon_item_info"];
}
//------------------------------------
// iconItemOpen
//------------------------------------
- (NSImage*)iconItemOpen
{
	return [self createImage:@"icon_item_open"];
}
//------------------------------------
// iconItems
//------------------------------------
- (NSImage*)iconItems
{
	return [self createImage:@"icon_items"];
}
//------------------------------------
// iconSelectOff
//------------------------------------
- (NSImage*)iconSelectOff
{
	return [self createImage:@"icon_select_off"];
}
//------------------------------------
// iconExport
//------------------------------------
- (NSImage*)iconExport
{
	return [self createImage:@"icon_export"];
}
//------------------------------------
// iconDelete
//------------------------------------
- (NSImage*)iconDelete
{
	return [self createImage:@"icon_delete"];
}
//------------------------------------
// iconTrash
//------------------------------------
- (NSImage*)iconTrash
{
	return [self createImage:@"icon_trash"];
}

@end
