#import "ImageBindExtension.h"
#import "UserDefaultsExtension.h"

@implementation NSObject(imageBindExtension_)

//------------------------------------
// getMameIconImage
//------------------------------------
- (NSImage*)getMameIconImage:(int)no
{
	NSString *imageName = @"icon_mame_sdlmame";

	switch(no){
		case MAME_EXEC_TYPE_SDLMAME:
			imageName = @"icon_mame_sdlmame";
			break;
		case MAME_EXEC_TYPE_MAMEOSX:
			imageName = @"icon_mame_mameosx";
			break;
		case MAME_EXEC_TYPE_MACMAME:
			imageName = @"icon_mame_macmame";
			break;
	}
	// create image
	NSImage *image = [[[NSImage alloc] initByReferencingFile:[[NSBundle mainBundle] pathForResource:imageName ofType:@"png"]] autorelease];
	[image setSize:NSMakeSize(14,14)];
	[image setScalesWhenResized:YES];

	return image;
}
//------------------------------------
// getMameButtonImage
//------------------------------------
- (NSImage*)getMameButtonImage:(int)no
{
	NSString *imageName = @"btn_mame_sdlmame";

	switch(no){
		case MAME_EXEC_TYPE_SDLMAME:
			imageName = @"btn_mame_sdlmame";
			break;
		case MAME_EXEC_TYPE_MAMEOSX:
			imageName = @"btn_mame_mameosx";
			break;
		case MAME_EXEC_TYPE_MACMAME:
			imageName = @"btn_mame_macmame";
			break;
	}

	return [NSImage imageNamed:imageName];
}
//------------------------------------
// getRomsIconImage
//------------------------------------
- (NSImage*)getRomsIconImage:(int)no
{
	NSString *imageName = @"icon_roms";

	switch(no){
		case DEFAULT_ROMS_TYPE_ALL:
			imageName = @"icon_roms";
			break;
		case DEFAULT_ROMS_TYPE_AVAILABLE:
			imageName = @"icon_roms_available";
			break;
		case DEFAULT_ROMS_TYPE_MISSING:
			imageName = @"icon_roms_missing";
			break;
	}
	// create image
	NSImage *image = [[[NSImage alloc] initByReferencingFile:[[NSBundle mainBundle] pathForResource:imageName ofType:@"png"]] autorelease];
	[image setSize:NSMakeSize(14,14)];
	[image setScalesWhenResized:YES];

	return image;
}
//------------------------------------
// getRomsButtonImage
//------------------------------------
- (NSImage*)getRomsButtonImage:(int)no
{
	NSString *imageName = @"btn_roms";

	switch(no){
		case DEFAULT_ROMS_TYPE_ALL:
			imageName = @"btn_roms";
			break;
		case DEFAULT_ROMS_TYPE_AVAILABLE:
			imageName = @"btn_roms_available";
			break;
		case DEFAULT_ROMS_TYPE_MISSING:
			imageName = @"btn_roms_missing";
			break;
	}

	return [NSImage imageNamed:imageName];
}
//------------------------------------
// getCategoryIconImage
//------------------------------------
- (NSImage*)getCategoryIconImage:(int)no
{
	NSString *imageName = @"icon_playlist";

	if(no == CATEGORY_TYPE_PLAYLIST){
		imageName = @"icon_playlist";
	}else{
		imageName = @"icon_browse";
	}

	// set image
	NSImage *image = [[[NSImage alloc] initByReferencingFile:[[NSBundle mainBundle] pathForResource:imageName ofType:@"png"]] autorelease];
	[image setSize:NSMakeSize(14,14)];
	[image setScalesWhenResized:YES];

	return image;
}
//------------------------------------
// getCategoryButtonImage
//------------------------------------
- (NSImage*)getCategoryButtonImage:(int)no
{
	NSString *imageName = @"btn_playlist";

	if(no == CATEGORY_TYPE_PLAYLIST){
		imageName = @"btn_playlist";
	}else{
		imageName = @"btn_browse";
	}

	return [NSImage imageNamed:imageName];
}
//------------------------------------
// getStatusIconImage
//------------------------------------
- (NSImage*)getStatusIconImage:(BOOL)isClone isExist:(BOOL)isExist isCurExist:(BOOL)isCurExist
{
	NSImage *image = nil;

	// not match
	if(isExist != isCurExist){
		image = [NSImage imageNamed: @"status_not_match"];
	}
	// match
	else{
		// exist
		if(isExist == YES){
			// parent
			if(isClone == NO){
				image = [NSImage imageNamed: @"status_parent"];
			}
			// clone
			else{
				image = [NSImage imageNamed: @"status_clone"];
			}
		}
		// not exist
		else{
			image = [NSImage imageNamed: @"status_not_exist"];
		}
	}

	return image;
}
//------------------------------------
// getAuditIconImage
//------------------------------------
- (NSImage*)getAuditIconImage:(NSString*)audit
{
	NSImage *image = nil;
	if([audit isEqualToString:@"bad"]){
		return [NSImage imageNamed: @"status_audit_bad"];
	}
	else if([audit isEqualToString:@"best available"]){
		return [NSImage imageNamed: @"status_audit_best"];
	}
	return image;
}

@end