#import "KeywordTypeTransformer.h"

@implementation KeywordTypeTransformer

+ (void)load
{
	[self setValueTransformer:[[KeywordTypeTransformer alloc] init] forName:@"KeywordTypeTransformer"];

}

+ (Class)transformedValueClass
{
    return [NSString self];
}

+ (BOOL)allowsReverseTransformation
{
    return YES;
}

- (id)transformedValue:(id)object
{

	id keywordTypeName = @"ID";

    if (object == nil) return keywordTypeName;

	int keywordType = [object intValue];

	switch( keywordType ) {
		case 0:
			keywordTypeName = @"ID";
			break;
		case 1:
			keywordTypeName = @"Title";
			break;
		case 2:
			keywordTypeName = @"Title(JP)";
			break;
	}

	return keywordTypeName;
}
- (id)reverseTransformedValue:(id)object
{

	id keywordType = [NSNumber numberWithInt:0];

    if (object == nil) return keywordType;


	if([object isEqualToString:@"ID"]){
		keywordType = [NSNumber numberWithInt:0];
	}
	if([object isEqualToString:@"Title"]){
		keywordType = [NSNumber numberWithInt:1];
	}
	if([object isEqualToString:@"Title(JP)"]){
		keywordType = [NSNumber numberWithInt:2];
	}

	return keywordType;
}

@end