#import "MAMEAttributeExtension.h"
#import "ThumbsExtension.h"
#import "ConvertExtension.h"
#import "FileAttributeExtension.h"
#import "ImageBindExtension.h"
#import "HelperExtension.h"
#import "UserDefaultsExtension.h"

@implementation NSObject(mameSettingsExtension_)

//------------------------------------
// createSdlMameArgs
//------------------------------------
- (NSMutableArray*)createSdlMameArguments
{

	NSMutableArray *args = [[[NSMutableArray alloc] init] autorelease];

	// -enable
	if([self defaultBoolValue:@"optSdlMameEnable"] == YES){

		// -video
		[args addObject:@"-video"];
		[args addObject:[self defaultStringValue:@"optSdlMameVideo"]];

		// -window
		if([self defaultBoolValue:@"optSdlMameFullScreen"] == NO){
			[args addObject:@"-window"];

			// -maximize
			if([self defaultBoolValue:@"optSdlMameMaximize"] == YES){
//				[args addObject:@"-maximize"];
			}else{
				[args addObject:@"-nomaximize"];
			}

		}else{
			[args addObject:@"-nowindow"];
			// -switchres
			if([self defaultBoolValue:@"optSdlMameSwitchRes"] == YES){
				[args addObject:@"-switchres"];
			}
		}

		// -keepaspect
		if([self defaultBoolValue:@"optSdlMameKeepAspect"] == YES){
			[args addObject:@"-keepaspect"];
		}

		// -sound
		if([self defaultBoolValue:@"optSdlMameSound"] == YES){
			// -sound
			[args addObject:@"-sound"];
			// -volume
			[args addObject:@"-volume"];
			[args addObject:[NSString stringWithFormat:@"%.0f",[self defaultFloatValue:@"optSdlMameVolume"]]];
			// -samplerate
			[args addObject:@"-samplerate"];
			[args addObject:[NSString stringWithFormat:@"%d",[self defaultIntValue:@"optSdlMameSampleRate"]]];
			// -audio_latency
			[args addObject:@"-audio_latency"];
			[args addObject:[NSString stringWithFormat:@"%d",[self defaultIntValue:@"optSdlMameAudioLatency"]]];

			// -samplepath
			NSString *samplePath = [self defaultStringValue:@"pathSdlMameSample"];
			if([self checkFileExist:samplePath] == FILE_EXIST_DIR){
				[args addObject:@"-samplepath"];
				[args addObject:samplePath];
			}

		}
		else{
			[args addObject:@"-nosound"];
		}


		// -mouse
		if([self defaultBoolValue:@"optSdlMameMouse"] == YES){
			[args addObject:@"-mouse"];
		}else{
			[args addObject:@"-nomouse"];
		}
		// -joystick
		if([self defaultBoolValue:@"optSdlMameJoystick"] == YES){
			[args addObject:@"-joystick"];
		}else{
			[args addObject:@"-nojoystick"];
		}

		// -autoframeskip
		if([self defaultBoolValue:@"optSdlMameAutoFrameSkip"] == YES){
			[args addObject:@"-autoframeskip"];
		}else{
			[args addObject:@"-noautoframeskip"];
		}
		// -skip_gameinfo
		if([self defaultBoolValue:@"optSdlMameSkipGameInfo"] == YES){
			[args addObject:@"-skip_gameinfo"];
		}else{
			[args addObject:@"-noskip_gameinfo"];
		}

		// -cheat
		if([self defaultBoolValue:@"optSdlMameCheat"] == YES){
			[args addObject:@"-cheat"];

/*
			// -cheat_file
			NSString *cheatFileName = [self defaultStringValue:@"optSdlMameCheatFileName"];
			if(![cheatFileName isEqualToString:@""]){
				[args addObject:@"-cheat_file"];
				[args addObject:cheatFileName];
			}
			// -cheatpath
			// need place same folder of sdlmame
			NSString *cheatPath = [self defaultStringValue:@"pathSdlMameCheat"];
			if([self checkFileExist:cheatPath] == FILE_EXIST_FILE){
				[args addObject:@"-cheatpath"];
				[args addObject:cheatPath];
			}
*/
		}else{
			[args addObject:@"-nocheat"];
		}

		// -vector effects
		if([self defaultBoolValue:@"optSdlMameVector"] == YES){
			// -antialias
			if([self defaultBoolValue:@"optSdlMameVectorAntialias"] == YES){
				[args addObject:@"-antialias"];
			}else{
				[args addObject:@"-noantialias"];
			}

			// -beam
			[args addObject:@"-beam"];
			[args addObject:[NSString stringWithFormat:@"%.1f",[self defaultFloatValue:@"optSdlMameVectorBeam"]]];

			// -flicker
			[args addObject:@"-flicker"];
			[args addObject:[NSString stringWithFormat:@"%.0f",[self defaultFloatValue:@"optSdlMameVectorFlicker"]]];
		}

		// -debug
		if([self defaultBoolValue:@"optSdlMameDebug"] == YES){
			[args addObject:@"-debug"];
		}
		if([self defaultBoolValue:@"optSdlMameDebugErrorLog"] == YES){
			[args addObject:@"-log"];
		}
		if([self defaultBoolValue:@"optSdlMameDebugVerbose"] == YES){
			[args addObject:@"-verbose"];
		}
		if([self defaultBoolValue:@"optSdlMameDebugUpdateInPause"] == YES){
			[args addObject:@"-update_in_pause"];
		}

	}

	return args;

}

//------------------------------------
// createMameOSXArguments
//------------------------------------
- (NSMutableArray*)createMameOSXArguments
{
	NSMutableArray *args = [[[NSMutableArray alloc] init] autorelease];

	if([self defaultBoolValue:@"optMameOSXEnable"] == YES){

		// -FullScreen
		if([self defaultBoolValue:@"optMameOSXFullScreen"] == YES){
			[args addObject:@"-FullScreen"];
			[args addObject:@"YES"];
		}else{
			[args addObject:@"-FullScreen"];
			[args addObject:@"NO"];
		}

	}

	return args;

}
//------------------------------------
// createBezelFilePath
//------------------------------------
- (NSString*)createBezelFilePath:(NSString*)parentId
							romId:(NSString*)romId
							bezelParams:(NSDictionary*)bezelParams
{

	// no bezel
	if([[bezelParams valueForKey:@"isBezel"] boolValue] == NO){
		return @"";
	}
	NSString *templateFileName = @"";
	NSString *layFileName = [bezelParams valueForKey:@"layout"];
	NSString *subLayFileName = [bezelParams valueForKey:@"subLayout"];
	BOOL showSubImage = [[bezelParams valueForKey:@"showSubImage"] boolValue];
	BOOL isSubImage = [[bezelParams valueForKey:@"isSubImage"] boolValue];
	float bezelAlpha = [[bezelParams valueForKey:@"bezelAlpha"] floatValue];

	// create path
	NSString *bezelTempPath = [self converToBezelTempPath];
	NSString *subImagePath = @"";

	BOOL isExistDir;
	BOOL isExistFile;
	BOOL isDrawSubImage = NO;

	// create sub image path
	if  (showSubImage == YES && isSubImage == YES &&
		(subLayFileName && ![subLayFileName isEqualToString:@""])){
		subImagePath = [self getThumbsImagePath:romId
											imageType:DEFAULT_IMAGE_TYPE_FLYER
											fileIndex:0
											maxIndex:nil
					];

		// change to no image
		if([subImagePath isEqualToString:@""]){		
			subImagePath = [[NSBundle mainBundle] pathForResource:@"image_noimage" ofType:@"png"];
		}
		isDrawSubImage = YES;
		templateFileName = subLayFileName;
	}else{
		templateFileName = layFileName;
	}
	
	// template file path
	NSString *templateFilePath = [self converToBezelTemplateFilePath:templateFileName];
	NSString *templateString = @"";

	// read templates file
	if([self checkFileExist:templateFilePath] == FILE_EXIST_FILE){
		templateString = [[[NSString alloc] initWithContentsOfFile:templateFilePath] autorelease];
	}else{
//		NSLog(@"template file not exist");
		return @"";
	}

	// layout file path
	NSString *layFolderPath = [self converToBezelTempFolderPath:bezelTempPath romId:parentId];
	NSString *layFilePath = [self converToBezelTempFilePath:layFolderPath romId:parentId];

	// replace sub image path
	if(isDrawSubImage == YES){

//		NSLog(@"layFolderPath=%@", layFolderPath);
//		NSLog(@"subImagePath=%@", subImagePath);

		// create relative path from layout folder
		NSArray *paths = [layFolderPath componentsSeparatedByString:@"/"];
		int i;
		NSString *relativePath = @"";
		for(i = 0; i < [paths count] - 1; i++){
			if(i < [paths count] - 2){
				relativePath = [relativePath stringByAppendingString:@"../"];
			}else{
				relativePath = [relativePath stringByAppendingString:@".."];
			}
		}

		NSString *subImageFilePath = [NSString stringWithFormat:@"%@%@", relativePath, subImagePath];
//		NSLog(@"subImageFilePath=%@", subImageFilePath);

		// replace image path
		templateString = [self replaceCharacter:templateString str1:@"..sub_image_file" str2:subImageFilePath];
	}

	// replace bezel_alpha
	templateString = [self replaceCharacter:templateString str1:@"..bezel_alpha" str2:[NSString stringWithFormat:@"%.1f", bezelAlpha]];

	//
	// bezels folder
	//
	isExistDir = NO;
	// folder is exist
	if([self checkFileExist:bezelTempPath] == FILE_EXIST_DIR){
		isExistDir = YES;
	}
	else if([self checkFileExist:bezelTempPath] == FILE_EXIST_FILE){
		isExistDir = NO;
	}
	// create new folder
	else{
		isExistDir = [self createNewDirectory:bezelTempPath];
	}
	// not exist
	if(isExistDir == NO){
		return @"";
	}

	//
	// layout folder
	//
	isExistDir = NO;
	// folder
	if([self checkFileExist:layFolderPath] == FILE_EXIST_DIR){
		isExistDir = YES;
	}
	// file
	else if([self checkFileExist:layFolderPath] == FILE_EXIST_FILE){
		isExistDir = NO;
	}
	// create
	else{
		isExistDir = [self createNewDirectory:layFolderPath];
	}
	// not exist
	if(isExistDir == NO){
//		NSLog(@"layout dir not exist");
		return @"";
	}

	//
	// layout file
	//
	isExistFile = NO;
	isExistDir = NO;
	if([self checkFileExist:layFilePath] == FILE_EXIST_FILE){
		isExistFile = YES;
//		[myFile removeFileAtPath:layFilePath handler:nil];
	}
	else if([self checkFileExist:layFilePath] == FILE_EXIST_DIR){
		isExistDir = YES;
	}

	// layout file is directory
	if(isExistDir == YES){
//		NSLog(@"layout file is directory");
		return @"";
	}

	//
	// create layout file
	//
	if([self createNewFileWithString:layFilePath string:templateString] == NO){
		return @"";
	}
	
	return bezelTempPath;

}
//------------------------------------
// createBezelPreviewImage
//------------------------------------
- (NSImage*)createBezelPreviewImage:(NSString*)romId
							bezelParams:(NSDictionary*)bezelParams
							showSubImage:(BOOL)showSubImage
							imageType:(int)imageType
							bezelAlpha:(float)bezelAlpha
{

	NSImage *bezelImage = nil;
	// snap image
	NSImage *snapImage = [self getThumbsImage:[self getThumbsImagePath:romId
													imageType:imageType
													fileIndex:0
													maxIndex:nil
												]
									hasImage:nil
						];
	// sub image
	NSImage *subImage = [self getThumbsImage:[self getThumbsImagePath:romId
													imageType:DEFAULT_IMAGE_TYPE_FLYER
													fileIndex:0
													maxIndex:nil
												]
									hasImage:nil
						];

	NSString *templateString = @"";
	NSDictionary *dictTemplateParams = nil;
	BOOL isTemplateSuccess = NO;
	BOOL isDrawSubImage = NO;

	// bezel value
	BOOL isBezel = [[bezelParams valueForKey:@"isBezel"] boolValue];
	NSString *fileName = @"";
	NSString *layFileName = [bezelParams valueForKey:@"layout"];
	NSString *subLayFileName = [bezelParams valueForKey:@"subLayout"];
	BOOL isSubImage = [[bezelParams valueForKey:@"isSubImage"] boolValue];

	if(isBezel == YES){

		// create path
		NSString *imagesPath = [self converToBezelImagesPath];

		// show sub image
		if  (showSubImage == YES && isSubImage == YES &&
			(subLayFileName && ![subLayFileName isEqualToString:@""])){
			fileName  = subLayFileName;
//			layFileName = [self converToBezelFileNameWithSubImage:layFileName];
			isDrawSubImage = YES;
		}else{
			fileName  = layFileName;
		}

		// template file path
		NSString *templateFilePath = [self converToBezelTemplateFilePath:fileName];

		// read templates file
		if([self checkFileExist:templateFilePath] == FILE_EXIST_FILE){
			templateString = [[[NSString alloc] initWithContentsOfFile:templateFilePath] autorelease];
			if(templateString != nil){
				dictTemplateParams = [self getBezelTemplateParams:templateString
														isSuccess:&isTemplateSuccess
									];
			}
		}
		// create bezel image
		NSString *imagePath = [NSString stringWithFormat:@"%@/%@.%@", imagesPath, fileName, @"png"];
		if([self checkFileExist:imagePath] == FILE_EXIST_FILE){
			bezelImage = [[[NSImage alloc] initByReferencingFile:imagePath] autorelease];	
		}
	}

	NSImage *image = nil;

	if( bezelImage != nil &&
		dictTemplateParams != nil &&
		isTemplateSuccess == YES
	){

		image = [[[NSImage alloc] initWithSize:[bezelImage size]] autorelease];

		// template values
		NSDictionary* screenParams = [dictTemplateParams valueForKey:@"screen"];
		NSDictionary* subImageParams = [dictTemplateParams valueForKey:@"subimage"];
		NSDictionary* bezelParams = [dictTemplateParams valueForKey:@"bezel"];

		// bezel values
		int bezel_width = [[bezelParams valueForKey:@"width"] intValue];
		int bezel_height = [[bezelParams valueForKey:@"height"] intValue];

		NSRect bezelImageRect = NSMakeRect(0, 0, [bezelImage size].width, [bezelImage size].height);
		NSPoint bezelPoint = NSMakePoint(0, 0);

		float scale_x = bezel_width / [image size].width;
		float scale_y = bezel_height / [image size].height;

		// draw image
		[image lockFocus];

		// for high image
//		[[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationHigh];

		// draw snapImage
		if(screenParams != nil){
			int screen_x = [[screenParams valueForKey:@"x"] intValue];
			int screen_y = [[screenParams valueForKey:@"y"] intValue];
			int screen_width = [[screenParams valueForKey:@"width"] intValue];
			int screen_height = [[screenParams valueForKey:@"height"] intValue];
			[snapImage setScalesWhenResized:YES];
			[snapImage setSize:NSMakeSize(
											screen_width * scale_x,
											screen_height * scale_y 
										)
			];
			NSRect snapImageRect = NSMakeRect(0, 0, [snapImage size].width, [snapImage size].height);
			NSPoint snapPoint = NSMakePoint(screen_x * scale_x, [bezelImage size].height - (screen_y * scale_y) - [snapImage size].height);

			[snapImage drawAtPoint:snapPoint fromRect:snapImageRect operation:NSCompositeSourceOver fraction:1.0];
		}

		// draw subImage
		if(isDrawSubImage == YES && subImageParams != nil){
			int sub_image_x = [[subImageParams valueForKey:@"x"] intValue];
			int sub_image_y = [[subImageParams valueForKey:@"y"] intValue];
			int sub_image_width = [[subImageParams valueForKey:@"width"] intValue];
			int sub_image_height = [[subImageParams valueForKey:@"height"] intValue];

			[subImage setScalesWhenResized:YES];
			[subImage setSize:NSMakeSize(
											sub_image_width * scale_x,
											sub_image_height * scale_y 
										)
			];
			NSRect subImageRect = NSMakeRect(0, 0, [subImage size].width, [subImage size].height);
			NSPoint subImagePoint = NSMakePoint(sub_image_x * scale_x, [bezelImage size].height - (sub_image_y * scale_y) - [subImage size].height);
			[subImage drawAtPoint:subImagePoint fromRect:subImageRect operation:NSCompositeSourceOver fraction:1.0];
		}

		// draw bezel
		[bezelImage drawAtPoint:bezelPoint fromRect:bezelImageRect operation:NSCompositeSourceOver fraction:bezelAlpha];

		[image unlockFocus];


	}else{
		image = snapImage;
	}

	return image;

}
//------------------------------------
// getBezelTemplateItems
//------------------------------------
- (NSMutableArray*)getBezelTemplateItems:(NSString*)string
								logString:(NSString**)logString
								isSuccess:(BOOL*)isSuccess
{

	NSMutableArray *items = [[[NSMutableArray alloc] init ] autorelease];
	*isSuccess = NO;

	// create xml document
	NSError *error = nil;
	NSXMLDocument *xmlDoc = [[[NSXMLDocument alloc] initWithXMLString:string options:nil error:&error] autorelease];
	if(error != nil){
		*logString = @"Can not create XML from file.";
		*isSuccess = NO;
		return nil;
	}

	//
	// <root>
	// 
	NSXMLNode *rootNode = [xmlDoc rootElement];
//	NSLog(@"rootNode=%@", [rootNode name]);
	// null or not match
	if(rootNode == nil || ![[rootNode name] isEqualToString:@"root"]){
		*logString = @"<root> is not found.";
		*isSuccess = NO;
		return nil;
	}

	//
	// <datainfo>
	// 
	NSXMLNode *dataInfoNode = [self getChildNode:rootNode name:@"datainfo"];
	// null
	if(dataInfoNode == nil){
		*logString = @"<datainfo> is not found.";
		*isSuccess = NO;
		return nil;
	}

	NSString *appname = [[self getChildNode:dataInfoNode name:@"appname"] stringValue];
	NSString *datatype = [[self getChildNode:dataInfoNode name:@"datatype"] stringValue];

	// null or not match
	if(appname == nil || ![appname isEqualToString:[self defaultAppName]]){
		*logString = @"<appname> is invalid.";
		*isSuccess = NO;
		return nil;
	}
	// null or not match
	if(datatype == nil || ![datatype isEqualToString:@"bezellist"]){
		*logString = @"<datatype> is invalid.";
		*isSuccess = NO;
		return nil;
	}

	//
	// <entries>
	//
	NSXMLNode *entriesNode = [self getChildNode:rootNode name:@"entries"];
	// null
	if(entriesNode == nil){
		*logString = @"<entries> is not found.";
		*isSuccess = NO;
		return nil;
	}

	//
	// children
	// 
	NSString *title;
	NSString *layout;
	NSString *sublayout;
	NSString *icon;
	int isSubImage;
	BOOL isBezel;

	NSEnumerator *enumNodes = [[entriesNode children] objectEnumerator];
	NSXMLNode *entryNode;
	while (entryNode = [enumNodes nextObject]){
		//
		// <entry>
		//
		if ([[entryNode name] isEqualToString:@"entry"]){

			title = [[self getChildNode:entryNode name:@"title"] stringValue];
			layout = [[self getChildNode:entryNode name:@"layout"] stringValue];
			sublayout = [[self getChildNode:entryNode name:@"sublayout"] stringValue];
			icon = [[self getChildNode:entryNode name:@"icon"] stringValue];
			isSubImage = [[[self getChildNode:entryNode name:@"issubimage"] stringValue] intValue];

			if(layout && ![layout isEqualToString:@""]){
				isBezel = YES;
			}else{
				isBezel = NO;
			}
			if(!sublayout || [sublayout isEqualToString:@""]){
				isSubImage = NO;
			}

			// add item
			[items addObject:[NSMutableDictionary dictionaryWithObjectsAndKeys:
											[NSNumber numberWithBool:isBezel], @"isBezel",
											title, @"title",
											layout, @"layout",
											sublayout, @"subLayout",
											icon, @"icon",
											[NSNumber numberWithInt:isSubImage], @"isSubImage",
											[NSNumber numberWithBool:NO], @"showSubImage",
											nil
										]
			];

			*isSuccess = YES;
		}

	}

	if(*isSuccess == NO){
		*logString = @"<entry> is not found.";
	}

	return items;

}
//------------------------------------
// getBezelTemplateParams
//------------------------------------
- (NSMutableDictionary*)getBezelTemplateParams:(NSString*)string isSuccess:(BOOL*)isSuccess
{

	NSMutableDictionary *dictParams = [[[NSMutableDictionary alloc] init ] autorelease];
	*isSuccess = NO;

	// create xml document
	NSError *error = nil;
	NSXMLDocument *xmlDoc = [[[NSXMLDocument alloc] initWithXMLString:string options:nil error:&error] autorelease];
	if(error != nil){
		*isSuccess = NO;
		return nil;
	}

	//
	// <mamelayout>
	// 
	NSXMLNode *rootNode = [xmlDoc rootElement];
//	NSLog(@"rootNode=%@", [rootNode name]);
	// null or not match
	if(rootNode == nil || ![[rootNode name] isEqualToString:@"mamelayout"]){
		*isSuccess = NO;
		return nil;
	}

	//
	// <view>
	// 
	NSXMLNode *viewNode = [self getChildNode:rootNode name:@"view"];
	// null
	if(viewNode == nil){
		*isSuccess = NO;
		return nil;
	}

	//
	// children
	// 
	int index;
	int x, y, width, height;
	NSString *element;

	NSEnumerator *enumNodes = [[viewNode children] objectEnumerator];
	NSXMLNode *childNode;
	NSXMLNode *boundsNode;
	while (childNode = [enumNodes nextObject]){
		//
		// <screen>
		//
		if ([[childNode name] isEqualToString:@"screen"]){
			index = [[[(NSXMLElement*)childNode attributeForName:@"index"] stringValue] intValue];
			if(index == 0){
				//
				// <bounds>
				//
				boundsNode = [self getChildNode:childNode name:@"bounds"];
				if(boundsNode != nil){
					x = [[[(NSXMLElement*)boundsNode attributeForName:@"x"] stringValue] intValue];
					y = [[[(NSXMLElement*)boundsNode attributeForName:@"y"] stringValue] intValue];
					width = [[[(NSXMLElement*)boundsNode attributeForName:@"width"] stringValue] intValue];
					height = [[[(NSXMLElement*)boundsNode attributeForName:@"height"] stringValue] intValue];
				}
				[dictParams setValue:[NSDictionary dictionaryWithObjectsAndKeys:
										[NSNumber numberWithInt:x], @"x",
										[NSNumber numberWithInt:y], @"y",
										[NSNumber numberWithInt:width], @"width",
										[NSNumber numberWithInt:height], @"height",
										nil
									]
							forKey:@"screen"
				];
				*isSuccess = YES;
			}
		}

		//
		// <bezel>
		//
		if ([[childNode name] isEqualToString:@"bezel"]){
			element = [[(NSXMLElement*)childNode attributeForName:@"element"] stringValue];

			// <bezel element="subimage">
			if([element isEqualToString:@"subimage"]){

				// <bounds>
				boundsNode = [self getChildNode:childNode name:@"bounds"];
				if(boundsNode != nil){
					x = [[[(NSXMLElement*)boundsNode attributeForName:@"x"] stringValue] intValue];
					y = [[[(NSXMLElement*)boundsNode attributeForName:@"y"] stringValue] intValue];
					width = [[[(NSXMLElement*)boundsNode attributeForName:@"width"] stringValue] intValue];
					height = [[[(NSXMLElement*)boundsNode attributeForName:@"height"] stringValue] intValue];
				}
				[dictParams setValue:[NSDictionary dictionaryWithObjectsAndKeys:
										[NSNumber numberWithInt:x], @"x",
										[NSNumber numberWithInt:y], @"y",
										[NSNumber numberWithInt:width], @"width",
										[NSNumber numberWithInt:height], @"height",
										nil
									]
							forKey:@"subimage"
				];
				*isSuccess = YES;
			}

			// <bezel element="bezel">
			if([element isEqualToString:@"bezel"]){

				// <bounds>
				boundsNode = [self getChildNode:childNode name:@"bounds"];
				if(boundsNode != nil){
					x = [[[(NSXMLElement*)boundsNode attributeForName:@"x"] stringValue] intValue];
					y = [[[(NSXMLElement*)boundsNode attributeForName:@"y"] stringValue] intValue];
					width = [[[(NSXMLElement*)boundsNode attributeForName:@"width"] stringValue] intValue];
					height = [[[(NSXMLElement*)boundsNode attributeForName:@"height"] stringValue] intValue];
				}
				[dictParams setValue:[NSDictionary dictionaryWithObjectsAndKeys:
										[NSNumber numberWithInt:x], @"x",
										[NSNumber numberWithInt:y], @"y",
										[NSNumber numberWithInt:width], @"width",
										[NSNumber numberWithInt:height], @"height",
										nil
									]
							forKey:@"bezel"
				];
				*isSuccess = YES;
			}
		}
	}

	return dictParams;

}

//------------------------------------
// getDriverStatusParams
//------------------------------------
- (NSDictionary*)getDriverStatusParams:(NSString*)string
{

	NSMutableDictionary *dict = [[[NSMutableDictionary alloc] init] autorelease];
	NSArray *cols;
	id record;

	if(string){
		NSArray *lines = [string componentsSeparatedByString:@" "];

		NSEnumerator *enumLines = [lines objectEnumerator];
		while (record = [enumLines nextObject]) {

			cols = [record componentsSeparatedByString:@"="];
			[dict setValue:[cols objectAtIndex:1] forKey:[cols objectAtIndex:0]];

		}
	}

	return dict;
	
}

//------------------------------------
// getBezelMenuItems
//------------------------------------
- (NSArray*)getBezelMenuItems
{
	// title, value, action, 
	return [[NSArray alloc] initWithObjects: 
				@"No Bezel,0,",
				@"Table,1,",
				@"Table,2,",
				@"Wood,3,",
				@"Wood,4,",
				@"Wide Screen,5,",
				@"iPhone,6,",
				@"iPhone,7,",
			nil];
}
@end