//
//  MAME_Tunes_AppDelegate.m
//  MAME_Tunes
//
//  Created by mametunes on 09/01/25.
//  Copyright mametunes 2009 . All rights reserved.
//

#import "MAME_Tunes_AppDelegate.h"

@implementation MAME_Tunes_AppDelegate

//------------------------------------
// initialize
//------------------------------------
+ (void)initialize {

    [self setupDefaults];

}
//------------------------------------
// setupDefaults
//------------------------------------
+ (void)setupDefaults
{

	NSDictionary *defaults = [NSDictionary dictionaryWithObjectsAndKeys:
				@"MAME_Tunes", @"optAppName",
				@"http://maws.mameworld.info/maws/romset/{$romId}", @"optWebInfoURL",
				[NSNumber numberWithInt:30], @"optMaxResults",
				[NSNumber numberWithInt:3], @"optMaxResultsType",
				[NSNumber numberWithInt:0], @"optMatrixDrawType",	// 0:first 1:delay
				[NSNumber numberWithInt:0], @"optTabViewMainIndex",
				[NSNumber numberWithBool:YES], @"optShowMenuIcon",
				[NSNumber numberWithBool:YES], @"optShowAlertBeforeChange",
				[NSNumber numberWithBool:YES], @"optSearchIncremental",
				[NSNumber numberWithBool:YES], @"optGalleryAutoClose",
				[NSNumber numberWithFloat:12.0], @"optFontSizeList",
				[NSNumber numberWithFloat:64.0], @"optRowHeightMain",
				[NSNumber numberWithFloat:64.0], @"optRowHeightClone",
				[NSNumber numberWithFloat:5.0], @"optMainMatrixCellScale",				
				[NSNumber numberWithInt:0], @"optShowRomsType",	// 0:all 1:available 2:missing
				[NSNumber numberWithInt:0], @"optThumbsImageTypeMain",	// 0:snap 1:title 2:flyer 3:inst 4:cabinet
				[NSNumber numberWithInt:0], @"optThumbsImageTypeClone",	// 0:snap 1:title 2:flyer 3:inst 4:cabinet
				[NSNumber numberWithInt:0], @"optWindowThemeNo",		
				[NSNumber numberWithInt:0], @"optLangType",	// 0:en 1:jp

				[NSNumber numberWithBool:NO], @"optDrawBackGroundImage",
				@"", @"pathBackGroundImage",
				[NSNumber numberWithInt:0], @"optBackGroundImageDrawType",	// 0:prop 1:fit 2:tile
				[NSNumber numberWithFloat:1.0], @"optBackGroundImageAlpha",

				@"", @"optSdlMameVersion",
				[NSNumber numberWithInt:0], @"optExecuteMameNo",	// 0:sdlmame 1:mameosx 2:macmame
				[NSNumber numberWithBool:NO], @"optSdlMameReplayEnable",
				[NSNumber numberWithBool:NO], @"optSdlMameBezelEnable",
				[NSNumber numberWithFloat:1.0], @"optSdlMameBezelAlpha",
				@"", @"optBezelLayout",

				// CATRGORY
				[NSNumber numberWithBool:NO], @"optCategoryAdjust",
				[NSNumber numberWithBool:NO], @"optCategorySplit",
				[NSNumber numberWithBool:NO], @"optCategoryClone",
	
				// SDLMAME
				[NSNumber numberWithBool:YES], @"optSdlMameEnable",	// args enable
				@"soft", @"optSdlMameVideo",	// -video
				[NSNumber numberWithBool:NO], @"optSdlMameFullScreen",	// -window
				[NSNumber numberWithBool:YES], @"optSdlMameMaximize",	// -maximize
				[NSNumber numberWithBool:NO], @"optSdlMameKeepAspect",	// -keepaspect
				[NSNumber numberWithBool:NO], @"optSdlMameSwitchRes",	// -switchres
				[NSNumber numberWithBool:YES], @"optSdlMameSound",	// -sound
				[NSNumber numberWithFloat:0], @"optSdlMameVolume",	// -volume
				[NSNumber numberWithInt:48000], @"optSdlMameSampleRate",	// -samplerate
				[NSNumber numberWithInt:1], @"optSdlMameAudioLatency",	// latency
				[NSNumber numberWithBool:NO], @"optSdlMameMouse",	// -mouse
				[NSNumber numberWithBool:NO], @"optSdlMameJoystick",	// -joystick
				[NSNumber numberWithBool:YES], @"optSdlMameAutoFrameSkip",	// -autoframeskip
				[NSNumber numberWithBool:NO], @"optSdlMameSkipGameInfo",	// -skip gameinfo
				[NSNumber numberWithBool:NO], @"optSdlMameCheat",	// -cheat
				[NSNumber numberWithBool:NO], @"optSdlMameVector",	// -vector option
				[NSNumber numberWithBool:NO], @"optSdlMameVectorAntialias",	// -antialias
				[NSNumber numberWithFloat:0.1], @"optSdlMameVectorBeam",	// -beam
				[NSNumber numberWithFloat:0], @"optSdlMameVectorFlicker",	// -flicker
				[NSNumber numberWithBool:YES], @"optSdlMameRomPath",	// -rompath
				[NSNumber numberWithBool:NO], @"optSdlMameSnapPath",	// -snapshot_directory
				// debug
				
				[NSNumber numberWithBool:YES], @"optSdlMameDebugAlert",
				[NSNumber numberWithBool:NO], @"optSdlMameDebug",	// -debug
				[NSNumber numberWithBool:NO], @"optSdlMameDebugErrorLog",	// -log
				[NSNumber numberWithBool:NO], @"optSdlMameDebugVerbose",	// -verbose
				[NSNumber numberWithBool:NO], @"optSdlMameDebugUpdateInPause",	// -update_in_pause

				// MAMEOSX
				[NSNumber numberWithBool:YES], @"optMameOSXEnable",	// args enable
				[NSNumber numberWithBool:NO], @"optMameOSXFullScreen",	// -FullScreen
				[NSNumber numberWithBool:YES], @"optMameOSXRomPath",	// -RomPath

				nil
	];

	[[NSUserDefaults standardUserDefaults] registerDefaults:defaults];
}

/**
    Returns the support folder for the application, used to store the Core Data
    store file.  This code uses a folder named "MAME_Tunes" for
    the content, either in the NSApplicationSupportDirectory location or (if the
    former cannot be found), the system's temporary directory.
 */

- (NSString *)applicationSupportFolder {

    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory, NSUserDomainMask, YES);
    NSString *basePath = ([paths count] > 0) ? [paths objectAtIndex:0] : NSTemporaryDirectory();
    return [basePath stringByAppendingPathComponent:@"MAME_Tunes"];
}


/**
    Creates, retains, and returns the managed object model for the application 
    by merging all of the models found in the application bundle and all of the 
    framework bundles.
 */
 
- (NSManagedObjectModel *)managedObjectModel {

    if (managedObjectModel != nil) {
        return managedObjectModel;
    }
	
    NSMutableSet *allBundles = [[NSMutableSet alloc] init];
    [allBundles addObject: [NSBundle mainBundle]];
    [allBundles addObjectsFromArray: [NSBundle allFrameworks]];
    
    managedObjectModel = [[NSManagedObjectModel mergedModelFromBundles: [allBundles allObjects]] retain];
    [allBundles release];
    
    return managedObjectModel;
}


/**
    Returns the persistent store coordinator for the application.  This 
    implementation will create and return a coordinator, having added the 
    store for the application to it.  (The folder for the store is created, 
    if necessary.)
 */

- (NSPersistentStoreCoordinator *) persistentStoreCoordinator {

    if (persistentStoreCoordinator != nil) {
        return persistentStoreCoordinator;
    }

    NSFileManager *fileManager;
    NSString *applicationSupportFolder = nil;
    NSURL *url;
    NSError *error;
    
    fileManager = [NSFileManager defaultManager];
    applicationSupportFolder = [self applicationSupportFolder];
    if ( ![fileManager fileExistsAtPath:applicationSupportFolder isDirectory:NULL] ) {
        [fileManager createDirectoryAtPath:applicationSupportFolder attributes:nil];
    }
    
    url = [NSURL fileURLWithPath: [applicationSupportFolder stringByAppendingPathComponent: @"MAME_Tunes.xml"]];
    persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel: [self managedObjectModel]];
    if (![persistentStoreCoordinator addPersistentStoreWithType:NSXMLStoreType configuration:nil URL:url options:nil error:&error]){
        [[NSApplication sharedApplication] presentError:error];
    }    

    return persistentStoreCoordinator;
}


/**
    Returns the managed object context for the application (which is already
    bound to the persistent store coordinator for the application.) 
 */
 
- (NSManagedObjectContext *) managedObjectContext {

    if (managedObjectContext != nil) {
        return managedObjectContext;
    }

    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil) {
        managedObjectContext = [[NSManagedObjectContext alloc] init];
        [managedObjectContext setPersistentStoreCoordinator: coordinator];
    }
    
    return managedObjectContext;
}


/**
    Returns the NSUndoManager for the application.  In this case, the manager
    returned is that of the managed object context for the application.
 */
 
- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)window {
    return [[self managedObjectContext] undoManager];
}


/**
    Performs the save action for the application, which is to send the save:
    message to the application's managed object context.  Any encountered errors
    are presented to the user.
 */
 
- (IBAction) saveAction:(id)sender {

    NSError *error = nil;
    if (![[self managedObjectContext] save:&error]) {
        [[NSApplication sharedApplication] presentError:error];
    }
}


/**
    Implementation of the applicationShouldTerminate: method, used here to
    handle the saving of changes in the application managed object context
    before the application terminates.
 */
 
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {

    NSError *error;
    int reply = NSTerminateNow;
    
	// store last state
	[olvPlaylist storeLastState];

    if (managedObjectContext != nil) {
        if ([managedObjectContext commitEditing]) {
            if ([managedObjectContext hasChanges] && ![managedObjectContext save:&error]) {
				
                // This error handling simply presents error information in a panel with an 
                // "Ok" button, which does not include any attempt at error recovery (meaning, 
                // attempting to fix the error.)  As a result, this implementation will 
                // present the information to the user and then follow up with a panel asking 
                // if the user wishes to "Quit Anyway", without saving the changes.

                // Typically, this process should be altered to include application-specific 
                // recovery steps.  

                BOOL errorResult = [[NSApplication sharedApplication] presentError:error];
				
                if (errorResult == YES) {
                    reply = NSTerminateCancel;
                } 

                else {
					
                    int alertReturn = NSRunAlertPanel(nil, @"Could not save changes while quitting. Quit anyway?" , @"Quit anyway", @"Cancel", nil);
                    if (alertReturn == NSAlertAlternateReturn) {
                        reply = NSTerminateCancel;	
                    }
                }
            }
        } 
        
        else {
            reply = NSTerminateCancel;
        }
    }
    
    return reply;
}


/**
    Implementation of dealloc, to release the retained variables.
 */
 
- (void) dealloc {

    [managedObjectContext release], managedObjectContext = nil;
    [persistentStoreCoordinator release], persistentStoreCoordinator = nil;
    [managedObjectModel release], managedObjectModel = nil;
    [super dealloc];
}


@end
