#import "MenuItemBezelMode.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKeyName = @"optSdlMameBezelEnable";

@implementation MenuItemBezelMode

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setMenuAction];
	[self setMenuState];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKeyName options:0 context:nil];
	[defaults addObserver:self forKeyPath:@"optExecuteMameNo" options:0 context:nil];

}
//------------------------------------
// changeBezelMode
//------------------------------------
- (IBAction)changeBezelMode:(id)sender
{
	BOOL isBezel = NO;
	if([sender tag] == 0){
		isBezel = NO;
	}else{
		isBezel = YES;
	}
	[self setDefaultBoolValue:isBezel key:defaultKeyName];

//	[self setMenuState];
}
//------------------------------------
// setMenuAction
//------------------------------------
- (void)setMenuAction
{

	// set action
	if([self defaultExecuteMameNo] == MAME_EXEC_TYPE_SDLMAME){
		[self setTarget:self];
		[self setAction:NSSelectorFromString(@"changeBezelMode:")];
	}else{
		[self setTarget:nil];
		[self setAction:nil];
	}

}
//------------------------------------
// setMenuState
//------------------------------------
- (void)setMenuState
{

	if([self defaultBoolValue:defaultKeyName] == YES){
		[self setState:1];
		[self setTag:0];
	}else{
		[self setState:0];
		[self setTag:1];
	}

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKeyName]){
		[self setMenuState];
	}
	else if([keyPath isEqualToString:@"optExecuteMameNo"]){
		[self setMenuAction];
	}
	
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{

	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKeyName];
	
	[super dealloc];
}

@end
