#import "MenuItemReplayMode.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKeyName = @"optSdlMameReplayEnable";

@implementation MenuItemReplayMode

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setMenuAction];
	[self setMenuState];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKeyName options:0 context:nil];
	[defaults addObserver:self forKeyPath:@"optExecuteMameNo" options:0 context:nil];
//	[defaults addObserver:self forKeyPath:@"optSdlMameEnable" options:0 context:nil];

}
//------------------------------------
// changeReplayMode
//------------------------------------
- (IBAction)changeReplayMode:(id)sender
{
	BOOL isReplay = NO;
	if([sender tag] == 0){
		isReplay = NO;
	}else{
		isReplay = YES;
	}
	[self setDefaultBoolValue:isReplay key:defaultKeyName];

//	[self setMenuState];
}
//------------------------------------
// setMenuAction
//------------------------------------
- (void)setMenuAction
{

	// set action
//	if( [self defaultExecuteMameNo] == MAME_EXEC_TYPE_SDLMAME &&
//		[self defaultBoolValue:@"optSdlMameEnable"] == YES
	if([self defaultExecuteMameNo] == MAME_EXEC_TYPE_SDLMAME
	){
		[self setTarget:self];
		[self setAction:NSSelectorFromString(@"changeReplayMode:")];
	}else{
		[self setTarget:nil];
		[self setAction:nil];
	}

}

//------------------------------------
// setMenuState
//------------------------------------
- (void)setMenuState
{

	if([self defaultBoolValue:defaultKeyName] == YES){
		[self setState:1];
		[self setTag:0];
	}else{
		[self setState:0];
		[self setTag:1];
	}

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKeyName]){
		[self setMenuState];
	}
//	else if([keyPath isEqualToString:@"optExecuteMameNo"] ||
//			[keyPath isEqualToString:@"optSdlMameEnable"]
	else if([keyPath isEqualToString:@"optExecuteMameNo"]
	){
		[self setMenuAction];
	}
	
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{

	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKeyName];
	
	[super dealloc];
}

@end
