#import "MenuItemShowRomsType.h"
#import "MAMEAttributeExtension.h"
#import "ImageBindExtension.h"
#import "UserDefaultsExtension.h"

@implementation MenuItemShowRomsType

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"showRomsTypeMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate:self];

}

//------------------------------------
// changeShowRomsType
//------------------------------------
- (IBAction)changeShowRomsType:(id)sender
{
	int showRomsType = [[sender representedObject] intValue];

	[self setDefaultIntValue:showRomsType key:@"optShowRomsType"];

}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *itemName;
	NSString *keyEquiv;
	int itemValue;
	int i;
	id record;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuArray = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuArray count]; i++){

		cols = [[menuArray objectAtIndex:i] componentsSeparatedByString:@","];
		
		itemName = [cols objectAtIndex:0];
		itemValue = [[cols objectAtIndex:1] intValue];
		keyEquiv = [cols objectAtIndex:2];

		// set action
 		SEL sel = NSSelectorFromString(@"changeShowRomsType:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:sel keyEquivalent:keyEquiv] autorelease];
		[menuItem setKeyEquivalentModifierMask:NSAlternateKeyMask];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithInt:itemValue]];

		// set image
		[menuItem setImage:[self getRomsIconImage:itemValue]];

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];

//	[menuArray release];

}
//------------------------------------
// updateSubMenu
//------------------------------------
- (void)updateSubMenu:(NSMenu*)aMenu
{

	int itemValue;
	id menuItem;

	int showRomsType = [self defaultShowRomsType];

	NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		itemValue = [[menuItem representedObject] intValue];
		// set state
		if(itemValue == showRomsType){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}
//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	// title, value, keyEquiv
	return [[NSArray alloc] initWithObjects: 
			@"All Roms,0,0",
			@"Available Roms,1,1",
			@"Missing Roms,2,2",
			nil
	];
}
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self updateSubMenu:menu];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
    [super dealloc];
}


@end
