#import "MenuItemThumbsImageType.h"
#import "ThumbsExtension.h"
#import "UserDefaultsExtension.h"

@implementation MenuItemThumbsImageType

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"thumbsImageTypeMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate:self];

}

//------------------------------------
// changeThumbsImageType
//------------------------------------
- (IBAction)changeThumbsImageType:(id)sender
{
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	int thumbsImageType = [[sender representedObject] intValue];

	if([self tag] == 0){
		[self setDefaultIntValue:thumbsImageType key:@"optThumbsImageTypeMain"];
		[nc postNotificationName:DEFAULT_NOTIF_IMAGE_TYPE_DID_CHANGED_MAIN object:self];
	}
	else if([self tag] == 1){
		[self setDefaultIntValue:thumbsImageType key:@"optThumbsImageTypeClone"];
		[nc postNotificationName:DEFAULT_NOTIF_IMAGE_TYPE_DID_CHANGED_CLONE object:self];
	}

}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *itemName;
	int itemValue;
	int i;
	id record;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuArray = [self thumbsImageTypeMenuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuArray count]; i++){

		cols = [[menuArray objectAtIndex:i] componentsSeparatedByString:@","];
		
		itemName = [cols objectAtIndex:0];
		itemValue = [[cols objectAtIndex:1] intValue];

		// set action
 		SEL sel = NSSelectorFromString(@"changeThumbsImageType:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithInt:itemValue]];

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];

//	[menuArray release];

}
//------------------------------------
// updateSubMenu
//------------------------------------
- (void)updateSubMenu:(NSMenu*)aMenu
{

	int itemValue;
	id menuItem;
	int thumbsImageType = 0;

	if([self tag] == 0){
		thumbsImageType = [self defaultThumbsImageTypeMain];
	}
	else if([self tag] == 1){
		thumbsImageType = [self defaultThumbsImageTypeClone];
	}

	NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		itemValue = [[menuItem representedObject] intValue];
		// set state
		if(itemValue == thumbsImageType){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}

//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self updateSubMenu:menu];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
    [super dealloc];
}


@end
