#import "MenuItemWebSearch.h"
#import "ViewPrefs.h"
#import "TBArrayController.h"

@implementation MenuItemWebSearch

//=======================================================================
// awake Web
//=======================================================================
- (void)awakeFromNib
{
	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"WebSearchMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate: self ];
}
//------------------------------------
// openPrefsWithWebSearch
//------------------------------------
- (IBAction)openPrefsWithWebSearch:(id)sender
{
	// open prefs tab
	[viewPrefs openPrefsTabWithIdentifier:PREFS_TAB_ID_WEBSEARCH];

}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{
	id record;
	NSString *itemName;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *items = [tbArrayController getAllObjects:@"searchlist"];
	NSSortDescriptor *descriptor=[[[NSSortDescriptor alloc] initWithKey:@"index" ascending:YES selector:nil] autorelease];
	items = [items sortedArrayUsingDescriptors:[NSArray arrayWithObject:descriptor]];

	// add item from search
    NSEnumerator *enumItems = [items objectEnumerator];
	NSMenuItem *menuItem;
    while (record = [enumItems nextObject]) {

		itemName = [record valueForKey:@"title"];

		SEL sel = NSSelectorFromString(@"searchItemWithWebSearch:");
		
		menuItem = [[[NSMenuItem alloc] initWithTitle:[record valueForKey: @"title"] action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:viewTarget];
		[menuItem setRepresentedObject:record];
         
        [aMenu addItem:menuItem];
    }

	// add item separator
	[aMenu addItem:[NSMenuItem separatorItem]];

	// add item for pereference
	menuItem = [[[NSMenuItem alloc] initWithTitle:@"Settings.." action:@selector(openPrefsWithWebSearch:) keyEquivalent:@""] autorelease];
 	[menuItem setTarget:self];
 	[aMenu addItem:menuItem];

    [self setSubmenu:aMenu];

}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
    [super dealloc];
}

//=======================================================================
#pragma mark - Delegate -
//=======================================================================
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self createSubMenu:menu];
}

@end
