#import "MenuSelectMameNo.h"
#import "MAMEAttributeExtension.h"
#import "ImageBindExtension.h"
#import "UserDefaultsExtension.h"

@implementation MenuSelectMameNo

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[super setDelegate:self];
	[self createMenuItem];

	// set button image
	[btnMenu setImage:[self getMameButtonImage:[self defaultExecuteMameNo]]];

}
//------------------------------------
// changeExecuteMameNo
//------------------------------------
- (IBAction)changeExecuteMameNo:(id)sender
{

	int mameNo = [[sender representedObject] intValue];

	// set default
	[self setDefaultIntValue:mameNo key:@"optExecuteMameNo"];

	// set button image
	[btnMenu setImage:[self getMameButtonImage:[self defaultExecuteMameNo]]];

}
//------------------------------------
// nullAction
//------------------------------------
- (IBAction)nullAction:(id)sender
{
	// nullAction
}
//------------------------------------
// createMenuItem
//------------------------------------
- (void)createMenuItem
{

	NSArray *cols;
	NSString *itemName;
	NSString *keyEquiv;
	int itemValue;
	int i;
	id record;

	// remove menuItem
     while (record = [[[self itemArray] objectEnumerator] nextObject]) {
		[self removeItem:record];
	}

	NSArray *menuArray = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuArray count]; i++){

		cols = [[menuArray objectAtIndex:i] componentsSeparatedByString:@","];
		
		itemName = [cols objectAtIndex:0];
		itemValue = [[cols objectAtIndex:1] intValue];
		keyEquiv = [cols objectAtIndex:2];

		// set action
 		SEL sel = NSSelectorFromString(@"changeExecuteMameNo:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:sel keyEquivalent:keyEquiv] autorelease];
		[menuItem setKeyEquivalentModifierMask:NSAlternateKeyMask];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithInt:itemValue]];

		// set image
		[menuItem setImage:[self getMameIconImage:itemValue]];

		[self addItem:menuItem];
	}

}

//------------------------------------
// updateMenuItem
//------------------------------------
- (void)updateMenuItem
{

	int itemValue;
	id menuItem;

	int mameNo = [self defaultExecuteMameNo];

	NSEnumerator *enumArray = [[self itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		itemValue = [[menuItem representedObject] intValue];
		// set state
		if(itemValue == mameNo){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}
//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	// title, value, keyEquiv
	return [[NSArray alloc] initWithObjects: 
			@"SDLMAME,0,1",
			@"MAME OS X,1,2",
			@"MacMAME,2,3",
			nil
	];
}
//=======================================================================
#pragma mark - Delegate -
//=======================================================================
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self updateMenuItem];
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
    [super dealloc];
}


@end
