#import "MenuSelectRomsType.h"
#import "MAMEAttributeExtension.h"
#import "ImageBindExtension.h"
#import "UserDefaultsExtension.h"

@implementation MenuSelectRomsType

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[super setDelegate:self];
	[self createMenuItem];

	// set button image
	[btnMenu setImage:[self getRomsButtonImage:[self defaultShowRomsType]]];

}
//------------------------------------
// changeShowRomsType
//------------------------------------
- (IBAction)changeShowRomsType:(id)sender
{

	int romsType = [[sender representedObject] intValue];

	// set default
	[self setDefaultIntValue:romsType key:@"optShowRomsType"];

	// set button image
	[btnMenu setImage:[self getRomsButtonImage:[self defaultShowRomsType]]];

}
//------------------------------------
// nullAction
//------------------------------------
- (IBAction)nullAction:(id)sender
{
	// nullAction
}
//------------------------------------
// createMenuItem
//------------------------------------
- (void)createMenuItem
{

	NSArray *cols;
	NSString *itemName;
	NSString *keyEquiv;
	int itemValue;
	int i;
	id record;

	// remove menuItem
     while (record = [[[self itemArray] objectEnumerator] nextObject]) {
		[self removeItem:record];
	}

	NSArray *menuArray = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuArray count]; i++){

		cols = [[menuArray objectAtIndex:i] componentsSeparatedByString:@","];
		
		itemName = [cols objectAtIndex:0];
		itemValue = [[cols objectAtIndex:1] intValue];
		keyEquiv = [cols objectAtIndex:2];

		// set action
 		SEL sel = NSSelectorFromString(@"changeShowRomsType:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:sel keyEquivalent:keyEquiv] autorelease];
		[menuItem setKeyEquivalentModifierMask:NSCommandKeyMask];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithInt:itemValue]];

		// set image
		[menuItem setImage:[self getRomsIconImage:itemValue]];

		[self addItem:menuItem];
	}

}

//------------------------------------
// updateMenuItem
//------------------------------------
- (void)updateMenuItem
{

	int itemValue;
	id menuItem;

	int romsType = [self defaultShowRomsType];

	NSEnumerator *enumArray = [[self itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		itemValue = [[menuItem representedObject] intValue];
		// set state
		if(itemValue == romsType){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}
//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	// title, value, keyEquiv
	return [[NSArray alloc] initWithObjects: 
			@"All Roms,0,1",
			@"Available Roms,1,2",
			@"Missing Roms,2,3",
			nil
	];
}
//=======================================================================
#pragma mark - Delegate -
//=======================================================================
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self updateMenuItem];
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
    [super dealloc];
}


@end
