/* ReportRomStatus */

#import <Cocoa/Cocoa.h>
#import "ProcInfoStatus.h"

@interface ReportRomStatus : NSObject
{

	IBOutlet id tbArrayController;
	IBOutlet id viewPrefs;
	IBOutlet id viewLog;
	IBOutlet NSWindow *folderSelectWindow;
	IBOutlet NSTextField *txtTitle;
	IBOutlet NSPopUpButton *pbtnFolders;
	IBOutlet NSProgressIndicator *indProc;

	int reportType_;
	NSString *logString_;

}
- (IBAction)openFolderSelectWindow:(id)sender;
- (IBAction)reportRomsFolder:(id)sender;
- (IBAction)reportImagesFolder:(id)sender;
- (IBAction)selectReportFolder:(id)sender;
- (IBAction)reportRomsAuditStatus:(id)sender;

- (BOOL)createFolderSelectWindow:(NSArray*)items reportType:(int)reportType;
- (void)createReportRomsFolder:(NSString*)folderPath reportType:(int)reportType;
- (void)createRomsAuditStatus:(int)reportType;
- (NSMutableArray*)createReportItemsRoms:(NSString*)folderPath
								items:(NSArray*)items
								keyRomId:(NSString*)keyRomId
								isParent:(BOOL)isParent
								reportType:(int)reportType;
- (NSMutableArray*)createReportItemsUnknown:(NSString *)filePath
									dictRoms:(NSMutableDictionary*)dictRoms
									dictClones:(NSMutableDictionary*)dictClones;
- (NSMutableArray*)createReportItemsAuditStatus:(NSArray*)items
								keyRomId:(NSString*)keyRomId
								isParent:(BOOL)isParent
								reportType:(int)reportType;

- (NSMutableDictionary*)createDictRoms;
- (NSMutableDictionary*)createDictClones;
- (NSString*)getRomsReportTypeName:(int)reportType;

- (void)handleProcStatusChanged:(int)status;

- (void)setReportType:(int)reportType;
- (int)reportType;
- (void)setLogString:(NSString*)logString;
- (NSString*)logString;
- (void)appendLogString:(NSString*)logString;
@end
