#import "RoundImageCell.h"
#import "ThumbsExtension.h"
#import "ConvertExtension.h"
#import "CellAttributeExtension.h"
#import "UserDefaultsExtension.h"

@implementation RoundImageCell
//------------------------------------
// init
//------------------------------------
- (id)init
{
    if (self = [super init])
	{
		[self setImageType:0];
		[self setRomId:@""];
		[self setIsExist:NO];
   }
    return self;
}
/*
//------------------------------------
// copyWithZone
//------------------------------------
- copyWithZone:(NSZone *)zone {
    RoundImageCell *cell = (RoundImageCell *)[super copyWithZone:zone];
    cell->image = [image retain];
    return cell;
}
*/
//------------------------------------
// drawInteriorWithFrame
//------------------------------------
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView*)controlView
{

//	NSString *romId = [self romId];
//	int imageType = [self imageType];

	//
	// image
	//
	NSImage *image = [self image];
/*
	NSImage *image = nil;

//	if(!image){
		// get thumbs image
		image = [self getThumbsImage:[self getThumbsImagePath:romId
													imageType:imageType
													fileIndex:0
													maxIndex:nil
									]
							hasImage:nil
				];
//		NSLog(@"create image=%@", romId);
//		[self setImage:image];
//	}
*/
	// draw background
//	[[NSColor blackColor] set];
//	NSRectFill(cellFrame);
//	NSBezierPath *bgPath = [self setRoundPathForRect:cellFrame radius:5];
//	[[NSColor colorWithCalibratedWhite:0.2 alpha:1.0] set];
//	NSRectFill(cellFrame);
//	[bgPath fill];

    NSPoint	imagePoint;

    imagePoint.x = cellFrame.origin.x;
    imagePoint.y = cellFrame.origin.y;

    // draw image
//	if([self image]){
	if(image){

//		NSImage *image = [[self image] copy];

		// set image size
		[image setSize:[self setCellImageSize:[image size]
									frameSize:cellFrame.size
									paddingSize:NSMakeSize(4,4)
						]
		];
		[image setScalesWhenResized:YES];

		// set image rect
		NSRect imageRect = [self setCellImageRect:[image size]
										frameRect:cellFrame
							];

		imagePoint.x += imageRect.origin.x;
		imagePoint.y += imageRect.origin.y;

        if([controlView isFlipped]) {
            imagePoint.y += [image size].height;
        }
		
		// set image round rect
		NSRect imageRoundRect = [self setCellImageRoundRect:[image size]
													frameRect:cellFrame
								];

/*
		// draw shadow rect
		NSRect bgRect = imageRoundRect;
		bgRect.origin.x -= 3;
		bgRect.origin.y -= 3;
		bgRect.size.width += 6;
		bgRect.size.height += 6;
		NSBezierPath *bgPath = [self setRoundPathForRect:bgRect radius:5];
		[[NSColor darkGrayColor] set];
		[bgPath fill];
*/

		// draw shadow rect
		NSRect shadowRect = imageRoundRect;
		shadowRect.origin.x += 4;
		shadowRect.origin.y += 4;
		NSBezierPath *shadowPath = [self setRoundPathForRect:shadowRect radius:5];
		[[NSColor darkGrayColor] set];
		[shadowPath fill];

		// draw image rect
		NSBezierPath *imagePath = [self setRoundPathForRect:imageRoundRect radius:5];
		[NSGraphicsContext saveGraphicsState];

//		[[NSGraphicsContext currentContext] setImageInterpolation: NSImageInterpolationHigh];

		[imagePath addClip];

		// draw image
		[image compositeToPoint:imagePoint operation:NSCompositeSourceOver];

		[NSGraphicsContext restoreGraphicsState];

//		[image release];

/*
		//
		// draw label
		//
		if([self isExist] == NO){
			// now origin.y is buggy
			NSRect imageBounds;
			imageBounds.origin.x = cellFrame.origin.x + imageRect.origin.x;
			imageBounds.origin.y = cellFrame.origin.y + imageRect.origin.y;
//			if([controlView isFlipped]) {
//				imageBounds.origin.y += (imageRect.size.height - imageRect.origin.y);
//			}
			imageBounds.size = imageRect.size;

			// draw label
			NSString *labelTitle = LABEL_NAME_NOT_FOUND;
			if(![labelTitle isEqualToString:@""]){
				NSSize stringSize = [labelTitle sizeWithAttributes:nil];
				if( imageBounds.size.width > stringSize.width + 8 &&
					imageBounds.size.height > stringSize.height + 4
				){
					// draw label
					[self drawLabelAndString:imageBounds
									withString:labelTitle
									fontSize:LABEL_STATUS_FSIZE
									fontColor:[NSColor whiteColor]
									labelColor:[self getLabelColor:LABEL_COLOR_NOT_FOUND]
									align:CELL_ALIGN_RIGHT
									valign:CELL_VALIGN_TOP
									hPadding:LABEL_STATUS_HPADDING
									vPadding:LABEL_STATUS_VPADDING
									radius:LABEL_STATUS_RADIUS
					];
				}
			}
		}
*/

    }

}
//------------------------------------
// romId
//------------------------------------
- (void)setRomId:(NSString*)romId
{
	[romId retain];
    [romId_ release];
    romId_ = romId;

}
- (NSString*)romId
{
	return romId_;
}
//------------------------------------
// imageType
//------------------------------------
- (void)setImageType:(int)imageType
{
	imageType_ = imageType;
}
- (int)imageType
{
	return imageType_;
}
//------------------------------------
// isExist
//------------------------------------
- (void)setIsExist:(BOOL)isExist
{
	isExist_ = isExist;
}
- (BOOL)isExist
{
	return isExist_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
    [super dealloc];
}

@end
