/* SetupAuditStatus.h */

#import <Cocoa/Cocoa.h>
#import "ProcInfoStatus.h"

@interface SetupAuditStatus : NSObject
{

	IBOutlet id viewLog;
	IBOutlet id viewProcStatus;
	IBOutlet id viewPrefs;
	IBOutlet id tbArrayController;

	IBOutlet NSProgressIndicator *indProc;

	NSString *logString_;

}
- (IBAction)importAuditStatus:(id)sender;
- (IBAction)exportAuditStatus:(id)sender;
- (IBAction)updateAllAuditStatus:(id)sender;

- (BOOL)updateAuditStatusWithRomId:(NSString*)romId isParent:(BOOL)isParent;
- (BOOL)updateAllAuditStatusWithString:(NSString*)resultString;

- (NSDictionary*)createAuditResultWithAppleScript:(NSString*)appPath
							folderPathString:(NSString*)folderPathString
							filePath:(NSString*)filePath;
- (NSString*)createAuditResultString:(NSString*)romId
							folderPathString:(NSString*)folderPathString
							showProc:(BOOL)showProc;
- (NSMutableDictionary*)createDictAuditStatus:(NSString*)string;
- (BOOL)updateAuditStatusWithItems:(NSArray*)items
						dict:(NSMutableDictionary*)dict
						keyRomId:(NSString*)keyRomId
						isParent:(BOOL)isParent
						showProc:(BOOL)showProc
						isClose:(BOOL)isClose;

- (void)handleProcStatusChanged:(int)status;

- (void)setLogString:(NSString*)logString;
- (NSString*)logString;
- (void)appendLogString:(NSString*)logString;

@end
