/* SetupMAMEList */

#import <Cocoa/Cocoa.h>
#import "ProcInfoStatus.h"

@interface SetupMAMEList : NSObject
{

	IBOutlet id MAME_Tunes_AppDelegate;
	IBOutlet id viewPrefs;
	IBOutlet id viewProcStatus;
	IBOutlet id viewLog;
	IBOutlet id tbArrayController;
	IBOutlet NSProgressIndicator *indProc;

	NSMutableArray *insertItemsParent_;
	NSMutableArray *deleteItemsParent_;
	NSMutableArray *unlinkItemsParent_;
	NSMutableArray *resetItemsParent_;
	int insertCountParent_;
	int updateCountParent_;
	int deleteCountParent_;
	int unlinkCountParent_;
	int resetCountParent_;

	NSMutableArray *insertItemsClone_;
	NSMutableArray *deleteItemsClone_;
	int insertCountClone_;
	int updateCountClone_;
	int deleteCountClone_;

	NSString *logString_;

}
- (IBAction)importMAMEList:(id)sender;
- (IBAction)exportMAMEList:(id)sender;

- (NSDictionary*)exportMAMEListWithAppleScript:(NSString*)appPath
									filePath:(NSString*)filePath;

- (BOOL)createRomlistFromXMLFile:(NSString*)filePath parseType:(int)parseType;
- (BOOL)createDictRomsWithFile:(NSString*)filePath
				dictParents:(NSMutableDictionary*)dictParents
				dictClones:(NSMutableDictionary*)dictClones
				dictCloneCounts:(NSMutableDictionary*)dictCloneCounts
				newVersion:(NSString**)newVersion;
- (BOOL)createDictRomsWithXMLString:(NSString*)xmlString
				dictParents:(NSMutableDictionary*)dictParents
				dictClones:(NSMutableDictionary*)dictClones
				dictCloneCounts:(NSMutableDictionary*)dictCloneCounts
				newVersion:(NSString**)newVersion;
- (NSString*)createRomlistFromXMLString:(NSString*)filePath isError:(BOOL*)isError;

- (BOOL)updateRomlist:(NSMutableDictionary*)dictParents
			dictClones:(NSMutableDictionary*)dictClones
			dictCloneCounts:(NSMutableDictionary*)dictCloneCounts;
- (BOOL)insertRomlist:(NSMutableDictionary*)dictParents
			dictCloneCounts:(NSMutableDictionary*)dictCloneCounts
			version:(NSString*)version;

- (BOOL)updateClonelist:(NSMutableDictionary*)dictClones;
- (BOOL)insertClonelist:(NSMutableDictionary*)dictClones
			version:(NSString*)version;
- (void)updateRomAndCloneRelation;

- (NSString*)createUnlinkResultString:(NSArray*)unlinkItems
							unlinkCount:(int)unlinkCount;
- (void)createUnlinkItems:(NSString*)romId
					title:(NSString*)title
					plistItem:(id)plistItem;

- (NSString *)createImportHeadString:(NSString*)oldVersion newVersion:(NSString*)newVersion;
- (NSString*)createImportResultString:(NSArray*)insertedItems
				deletedItems:(NSArray*)deletedItems
				insertedCount:(int)insertedCount
				updatedCount:(int)updatedCount
				deletedCount:(int)deletedCount
				isParent:(BOOL)isParent;
- (NSString*)createResetResultString:(NSArray*)resetItems
							resetCount:(int)resetCount;
- (NSString*)getMameVersionFromString:(NSString*)string;

- (void)handleProcStatusChanged:(int)status;

- (void)setLogString:(NSString*)logString;
- (NSString*)logString;
- (void)appendLogString:(NSString*)logString;

@end
