/* SetupRomSetting */

#import <Cocoa/Cocoa.h>
#import "ProcInfoStatus.h"

@interface SetupRomSetting : NSObject
{
	IBOutlet id tbArrayController;
	IBOutlet id viewLog;
	IBOutlet NSArrayController *romlistArrayController;
	IBOutlet NSProgressIndicator *indProc;

	int countImportRoms_;
	int countErrorRoms_;
	int countWarningRoms_;

	NSString *logString_;
}
- (IBAction)importRomSetting:(id)sender;
- (IBAction)exportRomSetting:(id)sender;

- (NSArray*)getExportTargetItems:(NSArray*)items;

- (BOOL)importRomSettingWithString:(NSString*)xmlString;
- (BOOL)createRomSettingWithNode:(NSXMLNode*)node;

- (BOOL)exportRomSettingWithItems:(NSArray*)items title:(NSString*)title rootFolder:(BOOL)rootFolder;
- (NSXMLDocument*)createXMLDocumentWithItems:(NSArray*)items
										title:(NSString*)title
										rootFolder:(BOOL)rootFolder
										isError:(BOOL*)isError;
- (NSXMLElement*)createDataInfoElement:(NSString*)title
								rootFolder:(BOOL)rootFolder
								dataType:(NSString*)dataType;
- (NSXMLElement*)createEntryElementWithItems:(NSArray*)items isError:(BOOL*)isError;

- (BOOL)updateRomSetting:(NSMutableDictionary*)dictRoms
				dictClones:(NSMutableDictionary*)dictClones
				romId:(NSString*)romId
				defaultRomId:(NSString*)defaultRomId
				labelColorNo:(int)labelColorNo
				comment:(NSString*)comment
				errorString:(NSString**)errorString;

- (NSMutableDictionary*)createDictRoms;
- (NSMutableDictionary*)createDictClones;

- (void)handleProcStatusChanged:(int)status;

- (NSString*)createLogString:(NSString*)title
						romId:(NSString*)romId
						defaultRomId:(NSString*)defaultRomId
						labelColorNo:(int)labelColorNo
						comment:(NSString*)comment
						errorString:(NSString*)errorString;
- (NSString *)createImportHeadString;

- (void)setLogString:(NSString*)logString;
- (NSString*)logString;
- (void)appendLogString:(NSString *)logString;

@end

