/* SetupSearchlist */

#import <Cocoa/Cocoa.h>
#import "ProcInfoStatus.h"
#import "MAMETypes.h"

@interface SetupSearchlist : NSObject
{
	IBOutlet id tbArrayController;
	IBOutlet id viewLog;
	IBOutlet NSArrayController *searchlistArrayController;
	IBOutlet NSProgressIndicator *indProc;

	NSString *logString_;
}
- (IBAction)importSearchlist:(id)sender;
- (IBAction)exportSearchlist:(id)sender;

- (BOOL)importSearchlistWithString:(NSString*)xmlString;
- (BOOL)createSearchlistWithNode:(NSXMLNode*)node
							index:(int)index;

- (BOOL)exportSearchlistWithItems:(NSArray*)items title:(NSString*)title rootFolder:(BOOL)rootFolder;
- (NSXMLDocument*)createXMLDocumentWithItems:(NSArray*)items
										title:(NSString*)title
										rootFolder:(BOOL)rootFolder
										isError:(BOOL*)isError;
- (NSXMLElement*)createDataInfoElement:(NSString*)title
								rootFolder:(BOOL)rootFolder
								dataType:(NSString*)dataType;
- (NSXMLElement*)createEntryElementWithItems:(NSArray*)items isError:(BOOL*)isError;
- (NSString*)createLogString:(NSString*)title
							description:(NSString*)description;

- (void)handleProcStatusChanged:(int)status;

- (void)setLogString:(NSString*)logString;
- (NSString*)logString;
- (void)appendLogString:(NSString *)logString;


@end

