/* TBArrayController */

#import <Cocoa/Cocoa.h>

@interface TBArrayController : NSObject
{
	IBOutlet NSArrayController *romlistArrayController;
	IBOutlet NSArrayController *clonelistArrayController;
	IBOutlet NSArrayController *searchlistArrayController;
	IBOutlet NSTreeController *playlistTreeController;

	IBOutlet id MAME_Tunes_AppDelegate;

}

- (int)getMaxIntValueFromEntityWithColumn:(NSString*)entityName column:(NSString*)column;
- (int)getMaxIntValueFromArrayWithColumn:(NSArray*)array column:(NSString*)column;
- (int)getMaxIndexFromChildItems:(NSManagedObject*)item;

- (NSManagedObjectContext*)getManagedObjectContext:(NSString*)entityName;

- (NSManagedObject*)getSelectedObject:(NSString*)entityName;
- (NSArray*)getSelectedObjects:(NSString*)entityName;
- (NSArray*)getAllObjects:(NSString*)entityName;
- (NSArray*)getChildObjects:(NSManagedObject*)parent;
- (NSArray*)getObjectsWithPred:(NSString*)entityName pred:(NSPredicate*)pred;

- (void)removeAllObjects:(NSString*)entityName;
- (void)removeObjectsWithArray:(NSArray*)array;
- (void)removeObject:(id)record;

- (void)addItemsToPlaylist:(NSManagedObject*)targetItem items:(NSArray*)items;
- (void)removeItemsFromPlaylist:(NSManagedObject*)targetItem items:(NSArray*)items;

- (NSManagedObject *)insertPlaylist:(int)index
					itemType:(int)itemType
					itemSubType:(int)itemSubType
					title:(NSString*)title
					value:(NSString*)value
					labelColorNo:(int)labelColorNo
					isFolder:(BOOL)isFolder
					parentItem:(id)parentItem;

- (void)addItemToParent:(NSManagedObject *)targetItem item:(NSManagedObject *)item maxNum:(BOOL)maxNum;
- (NSManagedObject*)getUpdateTargetItem:(NSManagedObject*)item;
- (NSMutableArray*)getTreeItems:(NSManagedObject*)item;
- (void)removeTreeItems:(NSManagedObject*)item;
- (void)resetItemIndex:(NSManagedObject*)insItem
			parentItem:(NSManagedObject*)parentItem
			targetItem:(NSManagedObject*)targetItem
			insIndex:(int)insIndex;
- (void)insertSearchlist:(int)index
					title:(NSString*)title
					url:(NSString*)url
					keywordType:(int)keywordType
					isTrim:(BOOL)isTrim;

@end
