/* UserDefaultsExtension */

#import <Cocoa/Cocoa.h>
#import "UserDefaultsStatus.h"
#import "MAMETypes.h"
#import "CategoryTypes.h"

@interface NSObject(userDefaultsExtension_)

- (void)setWindowRect:(NSWindow*)aWindow key:(NSString*)key;
- (void)setWindowPosition:(NSWindow*)aWindow key:(NSString*)key;
- (void)saveWindowRect:(NSWindow*)aWindow key:(NSString*)key;

- (void)setSplitViewRect:(NSSplitView *)aSplitView key:(NSString*)key;
- (void)saveSplitViewRect:(NSSplitView *)aSplitView key:(NSString*)key;
- (NSString*)splitViewRectString:(NSString*)key index:(int)index;

- (void)setTableColumnState:(NSTableView*)aTableView key:(NSString*)key;
- (void)saveTableColumnState:(NSTableView*)aTableView key:(NSString*)key;

- (void)setArrayControllerSortDescriptor:(NSArrayController*)aController key:(NSString*)key;
- (void)saveArrayControllerSortDescriptor:(NSArrayController*)aController key:(NSString*)key;

- (void)setSearchFieldRecentSearches:(NSSearchField*)searchField key:(NSString*)key;
- (void)saveSearchFieldRecentSearches:(NSSearchField*)searchField key:(NSString*)key;

- (void)saveLastSelectedIndex:(int)index key:(NSString*)key;
- (int)getLastSelectedIndex:(NSString*)key;

- (int)defaultMaxResults;
- (float)defaultMainMatrixCellSize;

- (int)defaultExecuteMameNo;
- (int)defaultShowRomsType;
- (int)defaultThumbsImageTypeMain;
- (int)defaultThumbsImageTypeClone;
- (int)defaultLangType;

- (void)setDefaultStringValue:(NSString*)string key:(NSString*)key;
- (NSString*)defaultStringValue:(NSString*)key;

- (void)setDefaultIntValue:(int)value key:(NSString*)key;
- (int)defaultIntValue:(NSString*)key;

- (void)setDefaultFloatValue:(float)value key:(NSString*)key;
- (float)defaultFloatValue:(NSString*)key;

- (void)setDefaultBoolValue:(BOOL)value key:(NSString*)key;
- (BOOL)defaultBoolValue:(NSString*)key;

- (void)setDefaultArrayValue:(NSArray*)array key:(NSString*)key;
- (NSArray*)defaultArrayValue:(NSString*)key;

- (NSString*)defaultSettingFilePath:(int)tag;
- (NSString*)defaultSettingFolderPath:(int)tag;
- (NSString*)getDefaultFilePathKey:(int)tag;
- (NSString*)getDefaultFolderPathKey:(int)tag;
- (NSString*)getDefaultRomsFolderPath;
- (NSString*)getDefaultRomsFolderPathString;
- (int)getDefaultImageFolderType:(int)no;
- (NSString*)getDefaultImageFolderTitle:(int)no;
- (NSString*)getDefaultCategoryColumn:(int)type;

- (NSString*)getAppSupportFolderPath;
- (NSString*)defaultOSVersionNo;
- (NSString*)defaultAppName;
- (NSString*)defaultAppVersion;
- (id)defaultInfoPlistValue:(NSString*)key;

@end
