/* ViewCategory */

#import <Cocoa/Cocoa.h>
#import "CategorylistTableView.h"
#import "ProcInfoStatus.h"
#import "CategoryTypes.h"

@interface ViewCategory : NSObject
{

    IBOutlet id viewMain;
	IBOutlet id viewKeywordSetting;
    IBOutlet id tbArrayController;
    IBOutlet NSArrayController *categorylistArrayController;

	IBOutlet NSTabView *tabViewPlaylist;
	IBOutlet NSTabView *tabViewControl;
	IBOutlet CategorylistTableView *tbvCategorylist;

	IBOutlet NSButton *btnMenuCategory;
	IBOutlet NSSearchField *txtSearchCategory;
	IBOutlet NSProgressIndicator *indProc;

	NSMutableArray *itemList_;

	int categoryNo_;

}

- (IBAction)changeCategory:(id)sender;
- (IBAction)reloadCategory:(id)sender;
- (IBAction)searchItem:(id)sender;
- (IBAction)searchWithDeselectItem:(id)sender;
- (IBAction)deselectItem:(id)sender;
- (IBAction)addSearchlist:(id)sender;

- (void)selectCategory:(int)categoryNo;
- (void)createCategoryWithLetter;
- (void)createCategoryWithColumn:(NSString*)column 
								adjust:(BOOL)adjust 
								split:(BOOL)split 
								trim:(BOOL)trim
								trimLen:(int)trimLen
								isSearchClone:(BOOL)isSearchClone 
								searchPattern:(NSString*)searchPattern;
- (NSMutableArray*)createAdjustItems:(NSArray*)items;
- (NSMutableArray*)createTrimItems:(NSArray*)items trimLen:(int)trimLen;
- (NSMutableArray*)createSplitItems:(NSArray*)items;
- (NSMutableArray*)createInsertItems:(NSArray*)items searchPattern:(NSString*)searchPattern;

- (void)searchItemWithItem:(NSManagedObject*)item;
- (NSPredicate*)createSearchPredicate:(NSString*)searchColumn
						searchString:(NSString*)searchString
						searchPattern:(NSString*)searchPattern;


- (void)addItemList:(NSArray*)items column:(NSString*)column isSearchClone:(BOOL)isSearchClone;
- (void)removeItemList;

- (void)setColumnHeaderTitle:(NSString*)title;
- (void)setCategoryButtonEnable;
- (void)handleProcStatusChanged:(int)status;
- (NSString*)replaceSeparateCharacters:(NSString*)string strSep:(NSString*)strSep;

- (BOOL)isDisplayCategorylist;
- (BOOL)isSelectTabViewPlaylist;
- (BOOL)canCreateSearchlist;
- (void)setCategoryNo:(int)categoryNo;
- (int)categoryNo;

- (NSArray*)searchLetterItems;

@end
