/* ViewClone */

#import <Cocoa/Cocoa.h>
#import "PreviewImageView.h"
#import "SearchTypes.h"
#import "ItemInfoStatus.h"
#import "ProcInfoStatus.h"
#import "BindObjectTypes.h"
#import "MAMETypes.h"

@interface ViewClone : NSObject
{

	IBOutlet id viewItemInfo;
	IBOutlet id executeMAME;
	IBOutlet id tbArrayController;
	IBOutlet id setupAuditStatus;
	IBOutlet id setupRomStatus;
	IBOutlet NSArrayController *clonelistArrayController;

	IBOutlet NSWindow *cloneWindow;

	IBOutlet NSTextField *txtStatus;

	IBOutlet NSButton *btnPlay;
	IBOutlet NSButton *btnReset;
	IBOutlet NSButton *btnUpdate;
	IBOutlet NSButton *btnShowInfo;
	IBOutlet NSButton *btnClose;

	IBOutlet PreviewImageView *imagePreview;

	IBOutlet NSSplitView *spvClone;
 
	NSString *parentId_;
	NSPredicate *parentPred_;
	NSString *cloneId_;

}
- (IBAction)openCloneWindow:(id)sender;
- (IBAction)closeCloneWindow:(id)sender;

- (IBAction)playItem:(id)sender;
- (IBAction)showItemInfo:(id)sender;

- (IBAction)updateItemAuditStatus:(id)sender;
- (IBAction)updateItemFileStatus:(id)sender;
- (IBAction)showItemInFinder:(id)sender;
- (IBAction)searchItemWithWebSearch:(id)sender;

- (IBAction)updateParentItem:(id)sender;
- (IBAction)resetParentItem:(id)sender;

- (void)playSelectedItem;
- (void)searchWithParentId:(NSString*)parentId cloneId:(NSString*)cloneId;
- (void)searchWithPredicate:(BOOL)withParent;

- (BOOL)updateParentRomlist:(NSString*)romId
				defaultRomId:(NSString*)defaultRomId
				cloneObject:(id)cloneObject;

- (void)setWindowStatus;
- (void)setResetButtonEnable;

- (void)setParentId:(NSString*)parentId;
- (NSString*)parentId;
- (void)setParentPred:(NSPredicate*)parentPred;
- (NSPredicate*)parentPred;
- (void)setCloneId:(NSString*)cloneId;
- (NSString*)cloneId;

- (BOOL)isKeyCloneWindow;
- (BOOL)isVisibleCloneWindow;

- (BOOL)hasPreviewRomId;
- (BOOL)hasPreviewImage;

@end
