/* ViewItemInfo */

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "BindObjectTypes.h"

@interface ViewItemInfo : NSObject
{

	IBOutlet id tbArrayController;
	IBOutlet id executeMAME;
	IBOutlet id setupAuditStatus;
	IBOutlet id setupRomStatus;

	IBOutlet NSArrayController *romlistArrayController;
	IBOutlet NSArrayController *clonelistArrayController;

	IBOutlet NSWindow *infoWindow;
	IBOutlet NSTabView *tabViewInfo;

	IBOutlet NSImageView *imagePreview;
	IBOutlet NSImageView *imageRomStatus;
	IBOutlet NSImageView *imageAuditStatus;

	IBOutlet NSTextField *txtRomId;
	IBOutlet NSTextField *txtTitle;
	IBOutlet NSTextField *txtManufacture;
	IBOutlet NSTextField *txtYear;
	IBOutlet NSTextField *txtAuditStatus;
	IBOutlet NSTextField *txtDriverStatus;
	IBOutlet NSTextView *txtFileStatus;
	IBOutlet NSComboBox *cbxComment;

	IBOutlet NSButton *btnUpdate;
	IBOutlet NSButton *btnUpdateInfo;
	IBOutlet NSButton *btnUpdateAudit;
	IBOutlet NSButton *btnSearchImage;
	IBOutlet NSButton *btnSearchItem;
	IBOutlet NSPopUpButton *pbtnSelectSet;

	IBOutlet NSBox *boxImageIndex;

	IBOutlet NSPopUpButton *pbtnLabelColor;

	IBOutlet NSButton *btnNext;
	IBOutlet NSButton *btnPrev;
	IBOutlet NSButton *btnCancel;

	IBOutlet WebView *webViewInfo;
	IBOutlet NSTextField *txtWebInfoURL;

	NSString *romId_;
	BOOL isParent_;
	BOOL showDefault_;

	int labelColorNo_;
	BOOL canEditLabelColorNo_;
	NSString *comment_;
	BOOL canEditComment_;

	NSArrayController *targetArrayController_;
	NSDictionary *params_;
	int arrayNo_;
	int imageIndex_;
	int imageMaxIndex_;

}
- (IBAction)openInfoWindow:(id)sender;
- (IBAction)closeInfoWindow:(id)sender;

- (IBAction)playItem:(id)sender;
- (IBAction)selectItem:(id)sender;
- (IBAction)changeItemInfo:(id)sender;
- (IBAction)changeItemSet:(id)sender;
- (IBAction)changeImageIndex:(id)sender;
- (IBAction)searchItemInfoWeb:(id)sender;

- (IBAction)updateItemAuditStatus:(id)sender;
- (IBAction)updateItemFileStatus:(id)sender;

- (IBAction)showItemInFinder:(id)sender;
- (IBAction)showImageInFinder:(id)sender;

- (void)createItemInfoWithSelectedObject;
- (BOOL)createItemInfoWithObject:(id)record arrayNo:(int)arrayNo showDefault:(BOOL)showDefault;
- (void)createItemInfoWithRomId:(NSString*)romId isParent:(BOOL)isParent;
- (BOOL)createItemInfoRom:(id)record isParent:(BOOL)isParent;
- (BOOL)createItemInfoWeb:(NSString*)urlString;

- (void)selectImageIndex:(int)tag;

- (void)createPreviewImage:(NSString*)romId imageIndex:(int)imageIndex;
- (void)createCommentComboBox:(NSString*)comment isCreate:(BOOL)isCreate;
- (void)setTitle:(id)record isParent:(BOOL)isParent langType:(int)langType;

- (void)setBoxImageIndexHidden;

- (BOOL)updateItemInfo;
- (BOOL)updateRomlist:(NSString*)romId
					labelColorNo:(int)labelColorNo
					comment:(NSString*)comment
					isChangedLabelColorNo:(BOOL)isChangedLabelColorNo
					isChangedComment:(BOOL)isChangedComment;

- (void)bindControlButtons;

- (void)setTargetArrayController:(int)arrayNo;
- (void)setArrayNo:(int)arrayNo;
- (int)arrayNo;

- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;
- (void)setRomId:(NSString*)romId;
- (NSString*)romId;

- (void)setComment:(NSString*)comment;
- (NSString*)comment;
- (void)setCanEditComment:(BOOL)canEditComment;
- (BOOL)canEditComment;

- (void)setLabelColorNo:(int)labelColorNo;
- (int)labelColorNo;
- (void)setCanEditLabelColorNo:(BOOL)canEditLabelColorNo;
- (BOOL)canEditLabelColorNo;

- (void)setIsParent:(BOOL)isParent;
- (BOOL)isParent;
- (void)setShowDefault:(BOOL)showDefault;
- (BOOL)showDefault;

- (void)setImageIndex:(int)imageIndex;
- (int)imageIndex;
- (void)setImageMaxIndex:(int)imageMaxIndex;
- (int)imageMaxIndex;

- (BOOL)isKeyInfoWindow;
- (BOOL)isVisibleInfoWindow;

@end
