/* ViewMain */

#import <Cocoa/Cocoa.h>
#import "PreviewImageView.h"
#import "SearchTypes.h"
#import "PlaylistItemTypes.h"
#import "ItemInfoStatus.h"
#import "ProcInfoStatus.h"
#import "BindObjectTypes.h"
#import "MAMETypes.h"

@interface ViewMain : NSObject
{

	IBOutlet id viewClone;
	IBOutlet id viewItemInfo;
	IBOutlet id viewPlaylist;
	IBOutlet id viewCategory;
	IBOutlet id executeMAME;
	IBOutlet id tbArrayController;
	IBOutlet id setupAuditStatus;
	IBOutlet id setupRomStatus;
	IBOutlet NSArrayController *romlistArrayController;

	IBOutlet NSWindow *mainWindow;

	IBOutlet NSSearchField *txtSearchField;
	IBOutlet NSButton *btnPagePrev;
	IBOutlet NSButton *btnPageNext;
	IBOutlet NSButton *btnPlay;
	IBOutlet NSProgressIndicator *indProc;

	IBOutlet NSButton *btnTabViewMainTable;
	IBOutlet NSButton *btnTabViewMainGrid;
	IBOutlet NSButton *btnSearchClone;
	IBOutlet NSButton *btnShowInfo;
	
	IBOutlet NSTabView *tabViewMainResult;
	IBOutlet NSTabView *tabViewMainStatus;
	IBOutlet NSTabView *tabViewMainSlider;

	IBOutlet PreviewImageView *imagePreview;

	IBOutlet NSSplitView *spvMain;
	IBOutlet NSSplitView *spvMainNavi;
	IBOutlet NSSplitView *spvMainHead;
 
	NSString *searchString_;
	NSPredicate *searchPred_;

	NSString *plistUniqueId_;
	BOOL plistIsFolder_;
	int plistItemType_;
	NSPredicate *plistPred_;

	NSPredicate *clistPred_;

	NSPredicate *itemsPred_;
	NSString *itemsTitle_;

	NSString *windowTitle_;

}
- (IBAction)playItem:(id)sender;
- (IBAction)showItemInfo:(id)sender;
- (IBAction)showCloneItem:(id)sender;
- (IBAction)changeInfoWindow:(id)sender;
- (IBAction)changeCloneWindow:(id)sender;

- (IBAction)updateItemAuditStatus:(id)sender;
- (IBAction)updateItemFileStatus:(id)sender;
- (IBAction)showItemInFinder:(id)sender;
- (IBAction)searchItemWithWebSearch:(id)sender;

- (IBAction)addItemToPlaylist:(id)sender;

- (IBAction)removeItem:(id)sender;
- (IBAction)removeItemFromPlaylist:(id)sender;

- (IBAction)changeTabViewMainIndex:(id)sender;

- (void)playSelectedItem;
- (void)searchWithString:(NSString*)searchString pred:(NSPredicate*)pred;
- (void)searchWithPlaylist:(NSString*)uniqueId
					title:(NSString*)title
					itemType:(int)itemType
					isFolder:(BOOL)isFolder
					pred:(NSPredicate*)pred;
- (void)searchWithCategorylist:(NSString*)title pred:(NSPredicate*)pred;
- (void)searchWithRomsType:(int)romsType;
- (void)searchWithItems:(NSArray*)items title:(NSString*)title;
- (void)searchWithPredicate:(BOOL)withString
					withPlist:(BOOL)withPlist
					withClist:(BOOL)withClist
					withItems:(BOOL)withItems;

- (void)changeTabViewMainResultIndex;
- (void)changeTabViewMainSliderIndex;
- (void)changeTabViewMainStatusIndex;
- (void)changeTabViewMainButtonEnable;
- (void)handleProcStatusChanged:(int)status;

- (void)setWindowTitle:(NSString*)windowTitle;
- (NSString*)windowTitle;

- (void)setSearchString:(NSString*)searchString;
- (NSString*)searchString;
- (void)setSearchPred:(NSPredicate*)searchPred;
- (NSPredicate*)searchPred;

- (void)setPlistUniqueId:(NSString*)plistUniqueId;
- (NSString*)plistUniqueId;
- (void)setPlistItemType:(int)plistItemType;
- (int)plistItemType;
- (void)setPlistIsFolder:(BOOL)plistIsFolder;
- (BOOL)plistIsFolder;

- (void)setPlistPred:(NSPredicate*)plistPred;
- (NSPredicate*)plistPred;

- (void)setClistPred:(NSPredicate*)clistPred;
- (NSPredicate*)clistPred;

- (void)setItemsPred:(NSPredicate*)itemsPred;
- (NSPredicate*)itemsPred;
- (void)setItemsTitle:(NSString*)itemsTitle;
- (NSString*)itemsTitle;

- (BOOL)canRemoveItemFromPlaylist;
- (BOOL)isKeyMainWindow;
- (BOOL)isSearchWithPlaylist;

- (BOOL)hasPreviewRomId;
- (BOOL)hasPreviewImage;

@end
