/* ViewPlaylist */

#import <Cocoa/Cocoa.h>
#import "PlaylistOutlineView.h"
#import "PlaylistItemTypes.h"
#import "CategoryTypes.h"

@interface ViewPlaylist : NSObject
{
	IBOutlet id viewMain;
	IBOutlet id viewCategory;
	IBOutlet id setupPlaylist;

	IBOutlet id tbArrayController;
	IBOutlet NSTreeController *playlistTreeController;

	IBOutlet NSWindow *mainWindow;
	IBOutlet PlaylistOutlineView *olvPlaylist;

	IBOutlet NSButton* btnAdd;
	IBOutlet NSButton* btnRemove;
	IBOutlet NSButton *btnMenuCategory;

	NSString *prevUniqueId_;
}
- (IBAction)addPlaylist:(id)sender;
- (IBAction)addSearchlist:(id)sender;
- (IBAction)addFolder:(id)sender;

- (IBAction)searchItem:(id)sender;
- (IBAction)searchWithSelectedItem:(id)sender;
- (IBAction)searchWithDeselectItem:(id)sender;
- (IBAction)removeItem:(id)sender;
- (IBAction)exportItem:(id)sender;
- (IBAction)showItem:(id)sender;

- (IBAction)editItem:(id)sender;
- (IBAction)deselectItem:(id)sender;

- (IBAction)nullAction:(id)sender;

- (void)addItem:(int)itemType
			itemSubType:(int)itemSubType
			title:(NSString*)title
			value:(NSString*)value
			isFolder:(BOOL)isFolder
			isSelect:(BOOL)isSelect
			isEdit:(BOOL)isEdit
			isSearch:(BOOL)isSearch;

- (void)searchItemWithItem:(NSManagedObject*)item;
- (void)addItemToPlaylistWithParams:(NSDictionary*)params;

- (void)setControlButtonEnable;

- (BOOL)isSelectItem;
- (BOOL)isSelectFolder;
- (BOOL)isSelectSearchlist;
- (BOOL)isKeyMainWindow;

- (BOOL)canAddPlaylist;
- (BOOL)isDisplayPlaylist;
- (BOOL)isSelectTabViewPlaylist;

@end
