/* ViewPrefs */

#import <Cocoa/Cocoa.h>
#import "PolishedWindow.h"
#import "PrefsAttributes.h"
#import "RomsFolderTableView.h"

@interface ViewPrefs : NSObject
{

	IBOutlet PolishedWindow *mainWindow;
	IBOutlet PolishedWindow *cloneWindow;
//	IBOutlet PolishedWindow *playerWindow;
	IBOutlet PolishedWindow *logWindow;
	IBOutlet NSWindow *prefsWindow;
	IBOutlet NSWindow *helpWindow;

	IBOutlet NSTabView *tabViewPrefs;

	IBOutlet NSArrayController *romsFolderArrayController;
	IBOutlet RomsFolderTableView *tbvRomsFolder;

	NSMutableArray *romsFolderList_;

}

- (IBAction)openPrefsWindow:(id)sender;
- (IBAction)openPrefsWindowWithSender:(id)sender;
- (IBAction)openHelpWindow:(id)sender;

- (IBAction)changeWindowTheme:(id)sender;

- (IBAction)selectFilePath:(id)sender;
- (IBAction)selectFolderPath:(id)sender;

- (IBAction)addRomsFolderItem:(id)sender;
//- (IBAction)editRomsFolderItem:(id)sender;
- (IBAction)moveRomsFolderItem:(id)sender;
- (IBAction)removeRomsFolderItem:(id)sender;
- (IBAction)saveRomsFolderItem:(id)sender;

- (NSMutableArray*)convertToRomsFolderItems:(NSArray*)array;
- (void)renumRomsFolderList;
- (NSMutableArray*)romsFolderList;

- (void)openPrefsTabWithIdentifier:(NSString*)identifier;

@end
