#import "ViewSearchlist.h"
#import "TBArrayController.h"
#import "FileAttributeExtension.h"
#import "DialogExtension.h"
#import "UserDefaultsExtension.h"

@implementation ViewSearchlist

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

}

//=======================================================================
// Event Actions
//=======================================================================
//=======================================================================
// action
//=======================================================================
//------------------------------------
// addItem
//------------------------------------
- (IBAction)addItem:(id)sender
{

	// get max index
	int index = [tbArrayController getMaxIntValueFromEntityWithColumn:@"searchlist" column:@"index"];
	index++;

	[self createItem:index
				title:@"New Search"
				url:@"http://"
				keywordType:0
				isTrim:NO
	];

	// update all index
//	[self updateSearchlistAllIndex:item];

	// reload data
	[searchlistArrayController rearrangeObjects];

	// select row
//	NSLog(@"numberOfRows=%d", [self numberOfRows]);
//	[self selectRow:[self numberOfRows] byExtendingSelection:NO];
//	[self reloadData];
}
//------------------------------------
// removeItem
//------------------------------------
- (IBAction)removeItem:(id)sender
{
	[searchlistArrayController remove:nil];
}

//------------------------------------
// createItem
//------------------------------------
- (void)createItem:(int)index
				title:(NSString*)title
				url:(NSString*)url
				keywordType:(int)keywordType
				isTrim:(BOOL)isTrim
{

	// create item
	[tbArrayController insertSearchlist:index
									title:title
									url:url
									keywordType:keywordType
									isTrim:isTrim
	];
}

//------------------------------------
// updateSearchlistAllIndex
//------------------------------------
- (void)updateSearchlistAllIndex:(NSManagedObject*)insertedItem
{

	NSArray *items = [searchlistArrayController arrangedObjects];

	id record;
	int index = -1;

	NSEnumerator *enumObjects = [items objectEnumerator];
	while (record = [enumObjects nextObject]) {

		// skip inserted record
		if (record == insertedItem) {
			continue;
		}

		index++;
		[record setValue:[NSNumber numberWithInt:index] forKey:@"index"];
 
	}

	// update last index
	index++;
	[insertedItem setValue:[NSNumber numberWithInt:index] forKey:@"index"];

}
//------------------------------------
// updateSearchlistLowerIndex
//------------------------------------
- (void)updateSearchlistLowerIndex:(NSMutableArray*)objectArray row:(int)row
{

	NSArray *items = [searchlistArrayController arrangedObjects];

	id record;
	int currentIndex = row;
	int i;

	// get currentIndex
	if(row > 0 && [items count] > 0){
		record = [items objectAtIndex:(row - 1)];
		currentIndex = [[record valueForKey:@"index"] intValue];
	}

	NSMutableArray *updatedRecords = [[NSMutableArray alloc] init];

	// update dropped record
	NSEnumerator *enumArray = [objectArray objectEnumerator];
	while (record = [enumArray nextObject]) {

		currentIndex++;
		[record setValue:[NSNumber numberWithInt:currentIndex] forKey:@"index"];
 
		// add updated record
		[updatedRecords addObject:record];
	}

	// update lower record
	for (i = row; i < [items count]; i++) {
		record = [items objectAtIndex:i];

		// contains updated records
		if ([updatedRecords containsObject:record]) {
			continue;
		}
		currentIndex++;
		[record setValue:[NSNumber numberWithInt:currentIndex] forKey:@"index"];
	}

	[updatedRecords release];

	// reload data
	[searchlistArrayController rearrangeObjects];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{	
	[super dealloc];
}

@end
